;ͻ
;Metal Warrior 2 - Actor handling routines + actor data                       
;Started in 9/1999!                                                           
;ͼ

MAXACTORS       = 8

AN_PLAYER       = 0
AN_GRENADE      = 1
AN_FIRSTITEM    = 2
AN_LASTITEM     = 3
AN_FIRSTENEMY   = 4
AN_LASTENEMY    = 7

AB_JUMP         = 1
AB_HIT          = 2

ACT_EMPTY       = 0
ACT_PLAYERRUN   = 1
ACT_PLAYERDUCK  = 2
ACT_PLAYERCLIMB = 3
ACT_PLAYERDEAD  = 4
ACT_PLAYERDOOR  = 5
ACT_ITEM        = 6
ACT_EXPLOSION   = 7
ACT_FISTMAN     = 8
ACT_GUNMAN      = 9
ACT_SHOTGUNMAN  = 10
ACT_MOTORIST    = 11
ACT_EAGLE       = 12
ACT_VETERAN     = 13
ACT_RAT         = 14
ACT_WORM        = 15
ACT_ROCK        = 16
ACT_PIG         = 17
ACT_SPIDER      = 18
ACT_SLIME       = 19
ACT_FATWORM     = 20
ACT_MOSQUITO    = 21
ACT_LIZARD      = 22
ACT_GUNUP       = 23
ACT_GUNDOWN     = 24
ACT_MINE        = 25
ACT_SIDEGUN     = 26
ACT_BIOMECH1    = 27
ACT_BIOMECH2    = 28
ACT_DROID       = 29
ACT_SMALLTANK   = 30
ACT_BIGTANK     = 31
ACT_FIREBALL    = 32
ACT_LASER       = 33
ACT_FLAMER      = 34
ACT_BOSS1       = 35
ACT_BOSS2       = 36
ACT_BOSS3       = 37
ACT_BOSS4       = 38
ACT_INNOCENT1   = 39
ACT_INNOCENT2   = 40
ACT_INNOCENT3   = 41
ACT_FISTMANDEAD = 42
ACT_GUNMANDEAD  = 43
ACT_SHOTGUNDEAD = 44
ACT_VETERANDEAD = 45
ACT_PIGDEAD     = 46
ACT_GUARDDEAD   = 47
ACT_BIGGUARDDEAD = 48
ACT_DBLEXPLOSION = 49
ACT_QUADEXPLOSION = 50
ACT_SIDELASER   = 51
ACT_BOSSGRENADE = 52
ACT_VERTICALLASER = 53
ACT_GUNSHOP     = 54
ACT_MUSICSHOP   = 55
ACT_BAR         = 56
ACT_OLDGAY      = 57
ACT_GUNSHOP2    = 58
ACT_DETECTIVE   = 59
ACT_GUNSHOP3    = 60
ACT_RECEPTIONIST = 61
ACT_BAND        = 62
ACT_ULTRASHRED  = 63
ACT_THESNAKE    = 64
ACT_FAUSTUS     = 65
ACT_GOAT        = 66
ACT_PROGRAMMER  = 67
ACT_IANBASE     = 68
ACT_IANRESCUED  = 69
ACT_GARAGEBAND  = 70
ACT_AI          = 71

ACTOR_START:

;Ŀ
;INITACTORS                                                                   
;                                                                             
;Sets each actor to "empty/inactive".                                         
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

initactors:     ldx #MAXACTORS-1
                lda #$00
iact_loop:      sta actt,x
                dex
                bpl iact_loop
                rts

;Ŀ
;MOVEACTORS                                                                   
;                                                                             
;Calls the move routine of each actor.                                        
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

moveactors:     lda #$00
                sta actorpresent
                ldx #MAXACTORS-1
moas_loop:      ldy actt,x                      ;Is the actor "empty"?
                beq moas_next
                lda actsd,x                     ;Decrease actor's shoot-delay
                beq moas_nosd
                dec actsd,x
moas_nosd:      lda actfls,x                    ;Is the actor "flashing"
                beq moas_nofls
                dec actfls,x
moas_nofls:     lda actorrouttbllo-1,y          ;Get address of actor
                sta moas_jump+1                 ;move routine
                lda actorrouttblhi-1,y
                sta moas_jump+2
moas_jump:      jsr $0000
moas_next:      dex
                bpl moas_loop
                rts

;Ŀ
;DOACTORS                                                                     
;                                                                             
;Divides all actors into sprites. This and dosprites take most of r-time :-)  
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

doactors:       lda #$00
                sta numspr
                ldx #MAXACTORS-1
doas_loop:      ldy actt,x                      ;Is the actor "empty"?
                beq doas_next
                stx doas_restx+1
                bne doactor
doas_restx:     ldx #$00
doas_next:      dex
                bpl doas_loop
                rts

doactor:        lda actfls,x                    ;Flashing?
                and #$01
                beq doa_nofls
                lda #$ff
doa_nofls:      sta tempval1                    ;Tempval1 = flashing
                lda actordatatbllo-1,y          ;Get address of actor
                sta srclo                       ;structure
                lda actordatatblhi-1,y
                sta srchi
                ldy #$00
                lda actxl,x                     ;Subtract the map position
                sec                             ;to get screen coordinates
                sbc scrollsubxl
                sta destlo
                lda actxh,x
                sbc scrollsubxh
                sta desthi
                lda destlo                      ;Subtract X-hotspot
                sec
                sbc (srclo),y
                sta destlo
                bcs doa_notover1
                dec desthi
doa_notover1:   iny
                lda actyl,x                     ;Subtract the map position
                sec                             ;to get screen coordinates
                sbc scrollsubyl
                sta destlo2
                lda actyh,x
                sbc scrollsubyh
                sta desthi2
                lda destlo2                     ;Subtract Y-hotspot
                sec
                sbc (srclo),y
                sta destlo2
                bcs doa_notover2
                dec desthi2
doa_notover2:   iny
                lda (srclo),y                   ;Get sprite formation type
                sta doa_jump+1                  ;(jump address)
                iny
                lda (srclo),y
                sta doa_jump+2
                iny
                lda actd,x
                clc
                beq doa_right
                lda (srclo),y                   ;Get number of "left" frame
doa_right:      adc actf,x                      ;Frame in accumulator, carry
                ldx numspr
doa_jump:       jmp $0000                       ;clear, all ready for jump

sprf_1x1:       adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR
                bcs doa_abort
                lda destlo
                sta sprxl,x
                lda desthi
                sta sprxh,x
                lda destlo2
                sta spryl,x
                lda desthi2
                sta spryh,x
                lda tempval1
                sta sprfls,x
                lda (srclo),y
                sta sprf,x
                inc numspr
                jmp doas_restx
doa_abort:      rts

sprf_1x2:       asl
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-1
                bcs doa_abort2
                lda destlo                      ;Carry now clear!
                sta sprxl,x
                sta sprxl+1,x
                lda desthi
                sta sprxh,x
                sta sprxh+1,x
                lda destlo2
                sta spryl,x
                adc #21
                sta spryl+1,x
                lda desthi2
                sta spryh,x
                adc #$00
                sta spryh+1,x
                lda tempval1
                sta sprfls,x
                sta sprfls+1,x
                lda (srclo),y
                sta sprf,x
                iny
                lda (srclo),y
                sta sprf+1,x
                inc numspr
                inc numspr
                jmp doas_restx
doa_abort2:     rts

sprf_2x1:       asl
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-1
                bcs doa_abort3
                lda destlo                      ;Carry clear :-)
                sta sprxl,x
                adc #24
                sta sprxl+1,x
                lda desthi
                sta sprxh,x
                adc #$00
                sta sprxh+1,x
                lda destlo2
                sta spryl,x
                sta spryl+1,x
                lda desthi2
                sta spryh,x
                sta spryh+1,x
                lda tempval1
                sta sprfls,x
                sta sprfls+1,x
                lda (srclo),y
                sta sprf,x
                iny
                lda (srclo),y
                sta sprf+1,x
                inc numspr
                inc numspr
                jmp doas_restx
doa_abort3:     rts

sprf_2x2:       asl
                asl
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-3
                bcs doa_abort4
                txa
                adc #$04                        ;Carry clear
                sta numspr
                lda destlo                      ;Carry still clear :-)
                sta sprxl,x
                sta sprxl+2,x
                adc #24
                sta sprxl+1,x
                sta sprxl+3,x
                lda desthi
                sta sprxh,x
                sta sprxh+2,x
                adc #$00
                sta sprxh+1,x
                sta sprxh+3,x
                lda destlo2
                sta spryl,x
                sta spryl+1,x
                clc
                adc #21
                sta spryl+2,x
                sta spryl+3,x
                lda desthi2
                sta spryh,x
                sta spryh+1,x
                adc #$00
                sta spryh+2,x
                sta spryh+3,x
                lda tempval1
                sta sprfls,x
                sta sprfls+1,x
                sta sprfls+2,x
                sta sprfls+3,x
                lda (srclo),y
                sta sprf,x
                iny
                lda (srclo),y
                sta sprf+1,x
                iny
                lda (srclo),y
                sta sprf+2,x
                iny
                lda (srclo),y
                sta sprf+3,x
                jmp doas_restx
doa_abort4:     rts

sprf_1x3:       sta tempval2
                asl
                adc tempval2
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-2
                bcs doa_abort4
                txa
                adc #$03                        ;Carry clear
                sta numspr
                lda destlo                      ;Carry now clear!
                sta sprxl,x
                sta sprxl+1,x
                sta sprxl+2,x
                lda desthi
                sta sprxh,x
                sta sprxh+1,x
                sta sprxh+2,x
                lda destlo2
                sta spryl,x
                adc #21
                sta spryl+1,x
                lda desthi2
                sta spryh,x
                adc #$00
                sta spryh+1,x
                lda spryl+1,x
                clc
                adc #21
                sta spryl+2,x
                lda spryh+1
                adc #$00
                sta spryh+2,x
                jmp doa_fillframes

sprf_3x2:       asl
                sta tempval2
                asl
                adc tempval2
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-5
                bcs doa_abort6
                jsr row3
                jsr row3
                txa
                ldx numspr
                sta numspr
                jmp doa_fillframes
doa_abort6:     rts

sprf_3x4:       asl
                asl
                sta tempval2
                asl
                adc tempval2
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-11
                bcs doa_abort7
                jsr row3
                jsr row3
                jsr row3
                jsr row3
                txa
                ldx numspr
                sta numspr
                jmp doa_fillframes
doa_abort7:     rts


row3:           lda destlo                      ;Carry now clear!
                sta sprxl,x
                clc
                adc #24
                sta sprxl+1,x
                lda desthi
                sta sprxh,x
                adc #$00
                sta sprxh+1,x
                lda sprxl+1,x
                clc
                adc #24
                sta sprxl+2,x
                lda sprxh+1,x
                adc #$00
                sta sprxh+2,x
                lda destlo2
                sta spryl,x
                sta spryl+1,x
                sta spryl+2,x
                clc
                adc #21
                sta destlo2
                lda desthi2
                sta spryh,x
                sta spryh+1,x
                sta spryh+2,x
                adc #$00
                sta desthi2
                inx
                inx
                inx
                rts

sprf_band:      sta tempval2
                asl
                asl
                adc tempval2
                adc #$08
                tay                             ;Y=index to frametable
                cpx #MAXSPR-4
                bcs doa_abort6
                txa
                adc #$05
                sta numspr
                lda destlo                      ;Carry now clear!
                sta sprxl,x
                sta sprxl+1,x
                clc
                adc #24
                sta sprxl+2,x
                lda desthi
                sta sprxh,x
                sta sprxh+1,x
                adc #$00
                sta sprxh+2,x
                lda sprxl+2,x
                clc
                adc #24
                sta sprxl+3,x
                sta sprxl+4,x
                lda sprxh+2,x
                adc #$00
                sta sprxh+3,x
                sta sprxh+4,x
                lda destlo2
                sta spryl,x
                sta spryl+2,x
                sta spryl+3,x
                clc
                adc #21
                sta spryl+1,x
                sta spryl+4,x
                lda desthi2
                sta spryh,x
                sta spryh+2,x
                sta spryh+3,x
                adc #$00
                sta spryh+1,x
                sta spryh+4,x

        ;This routine must be called only for really big actors (bosses!)
        ;because it is damn slow!

doa_fillframes: lda tempval1
                sta sprfls,x
                lda (srclo),y
                sta sprf,x
                iny
                inx
                cpx numspr
                bcc doa_fillframes
                jmp doas_restx

;Ŀ
;MOVEACTORX                                                                   
;                                                                             
;Does X-movement of an actor. Note: lowest 3 bits of x-speed aren't used, to  
;make smooth accelerations and brakes easy to do.                             
;                                                                             
;Parameters: X: Actor number                                                  
;Returns: -                                                                   
;Modifies: A                                                                  
;

moveactorx:     lda actsx,x
                beq mactx_pnot
                bmi mactx_neg
mactx_pos:      lsr
                lsr
                lsr
                clc
                adc actxl,x
                sta actxl,x
                bcc mactx_pnot
                inc actxh,x
mactx_pnot:     rts
mactx_neg:      eor #$ff
                clc
                adc #$01
                lsr
                lsr
                lsr
                sta mactx_sub+1
                sec
                lda actxl,x
mactx_sub:      sbc #$00
                sta actxl,x
                bcs mactx_nnot
                dec actxh,x
mactx_nnot:     rts

;Ŀ
;MOVEACTORY                                                                   
;                                                                             
;Does Y-movement of an actor. Note: lowest 3 bits of y-speed aren't used, to  
;make smooth accelerations and brakes easy to do.                             
;                                                                             
;Parameters: X: Actor number                                                  
;Returns: -                                                                   
;Modifies: A                                                                  
;

moveactory:     lda actsy,x
                beq macty_pnot
                bmi macty_neg
macty_pos:      lsr
                lsr
                lsr
                clc
                adc actyl,x
                sta actyl,x
                bcc macty_pnot
                inc actyh,x
macty_pnot:     rts
macty_neg:      eor #$ff
                clc
                adc #$01
                lsr
                lsr
                lsr
                sta macty_sub+1
                sec
                lda actyl,x
macty_sub:      sbc #$00
                sta actyl,x
                bcs macty_nnot
                dec actyh,x
macty_nnot:     rts

;Ŀ
;ACCACTORX                                                                    
;                                                                             
;Does X-acceleration of an actor. Note: acceleration and speed limit must     
;always be same sign!                                                         
;                                                                             
;Parameters: X: Actor number, A: acceleration, Y: Speed limit                 
;Returns: -                                                                   
;Modifies: A,Y,Tempval1                                                       
;

accactorx:      sty tempval1
                clc
                tay                             ;Just to get the flags
                bmi aact_xneg
aact_xpos:      adc actsx,x
                bmi aact_xposnl                 ;If speed still negative,
                cmp tempval1                    ;need not check limit
                bcc aact_xposnl
                lda tempval1
aact_xposnl:    sta actsx,x
                rts
aact_xneg:      adc actsx,x
                bpl aact_xnegnl
                cmp tempval1
                bcs aact_xnegnl
                lda tempval1
aact_xnegnl:    sta actsx,x
                rts

;Ŀ
;ACCACTORY                                                                    
;                                                                             
;Does Y-acceleration of an actor. Note: acceleration and speed limit must     
;always be same sign!                                                         
;                                                                             
;Parameters: X: Actor number, A: acceleration, Y: Speed limit                 
;Returns: -                                                                   
;Modifies: A,Y,Tempval1                                                       
;

accactory:      sty tempval1
                clc
                tay                             ;Just to get the flags
                bmi aact_yneg
aact_ypos:      adc actsy,x
                sta actsy,x
                bmi aact_yposnl                 ;If speed still negative,
                cmp tempval1                    ;need not check limit
                bcc aact_yposnl
                lda tempval1
                sta actsy,x
aact_yposnl:    rts
aact_yneg:      adc actsy,x
                sta actsy,x
                bpl aact_ynegnl
                cmp tempval1
                bcs aact_ynegnl
                lda tempval1
                sta actsy,x
aact_ynegnl:    rts

;Ŀ
;BRAKEACTORX                                                                  
;                                                                             
;Brakes X-speed of an actor towards zero.                                     
;                                                                             
;Parameters: X: Actor number, A: deceleration (always positive)               
;Returns: -                                                                   
;Modifies: A,Tempval1                                                         
;

brakeactorx:    sta tempval1
                lda actsx,x
                beq bact_xdone
                bmi bact_xneg
bact_xpos:      sec
                sbc tempval1
                bpl bact_xdone
                lda #$00
bact_xdone:     sta actsx,x
                rts
bact_xneg:      clc
                adc tempval1
                bmi bact_xdone
                lda #$00
                sta actsx,x
                rts

;Ŀ
;BRAKEACTORY                                                                  
;                                                                             
;Brakes Y-speed of an actor towards zero.                                     
;                                                                             
;Parameters: X: Actor number, A: deceleration (always positive)               
;Returns: -                                                                   
;Modifies: A,Tempval1                                                         
;

brakeactory:    sta tempval1
                lda actsy,x
                beq bact_ydone
                bmi bact_yneg
bact_ypos:      sec
                sbc tempval1
                bpl bact_ydone
                lda #$00
bact_ydone:     sta actsy,x
                rts
bact_yneg:      clc
                adc tempval1
                bmi bact_ydone
                lda #$00
                sta actsy,x
                rts

;Ŀ
;REVERSEACTOR                                                                 
;                                                                             
;Reverses actor direction.                                                    
;                                                                             
;Parameters: X: Actor number                                                  
;Returns: -                                                                   
;Modifies: A,Tempval1                                                         
;

reverseactor:   lda actd,x
                eor #$01
                sta actd,x
                rts

;Ŀ
;LANDINGCHECK                                                                 
;                                                                             
;Checks if a groundbased actor who occasionally jumps, has landed.            
;Note! Getcharpos must have been called and the checkingpos. NOT modified!    
;                                                                             
;Parameters: -                                                                
;Returns: C=0 no landing, C=1 landed                                          
;Modifies: A,Y                                                                
;

landingcheck:   lda actsy,x
                bmi lchk_noground
                beq lchk_noground
                jsr getcharinfo
                and #CI_GROUND
                beq lchk_noground
dolanding:      lda actyl,x
                and #$f8
                sta actyl,x
                lda #$00
                sta actbits,x
                sta actsy,x
                sta actsx,x
                sta actf,x
                sec
                rts
lchk_noground:  clc
                rts

;Ŀ
;ANIMDELAY                                                                    
;                                                                             
;Performs the common animation delay, probably needed 666 times.              
;                                                                             
;Parameters: A=number of frames to wait                                       
;Returns: C=0 no next frame, C=1 time for next frame                          
;Modifies: A,Tempval1                                                         
;
animdelay:      sta tempval1
                inc actfd,x
                lda actfd,x
                cmp tempval1
                bcc animdelay2
                lda #$00
                sta actfd,x
animdelay2:     rts

;Ŀ
;CHECKOBST                                                                    
;                                                                             
;Checks obstacles on left and right side of actor when in walking/running     
;motion. Zeroes X-speed if obstacle detected. Note: Getcharpos must have      
;been called and checkingpos unaltered. After this the checkingpos. is one    
;char above feet and one char left/right depending on direction.              
;                                                                             
;Parameters: -                                                                
;Returns: C=0 no obstacle, C=1 obstacle                                       
;Modifies: A,Y                                                                
;

checkobst:      jsr movecharposup1
checkobst2:     lda actsx,x
                beq chko_noobst
                bmi chko_left
chko_right:     jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                beq chko_noobst
                lda #$00
                sta actsx,x
                sec
                rts
chko_left:      jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                beq chko_noobst
                lda #$00
                sta actsx,x
                sec
                rts
chko_noobst:    clc
                rts

;Ŀ
;CHECKOBSTY                                                                   
;                                                                             
;Checks obstacles on up & down side of actor for flying motion.               
;motion. Zeroes Y-speed if obstacle detected. Note: Getcharpos must have      
;been called and checkingpos unaltered. Checkingposition is not affected!     
;                                                                             
;Parameters: -                                                                
;Returns: C=0 no obstacle, C=1 obstacle                                       
;Modifies: A,Y                                                                
;

checkobsty:     lda actsy,x
                beq chkoy_noobst
                bmi chkoy_up
chkoy_down:     jsr movecharposdown1
                jsr getcharinfo
                pha
                jsr movecharposup1
                jmp chkoy_common
chkoy_up:       jsr movecharposup1
                jsr getcharinfo
                pha
                jsr movecharposdown1
chkoy_common:   pla
                and #CI_OBSTACLE
                beq chkoy_noobst
                lda #$00
                sta actsy,x
                sec
                rts
chkoy_noobst:   clc
                rts

;Ŀ
;CHECKSTAIRS                                                                  
;                                                                             
;Call this after moving in X-direction. Getcharpos isn't needed, because it   
;is called here.                                                              
;                                                                             
;Parameters: -                                                                
;Returns: C=1 found ground, C=0 didn't                                        
;Modifies: A,Y                                                                
;

checkstairs:    jsr getcharpos
                jsr getcharinfo
                and #CI_GROUND
                bne chks_ok
                jsr movecharposup1
                jsr getcharinfo
                and #CI_GROUND
                beq chks_notup
                lda actyl,x
                sec
                sbc #8
                sta actyl,x
                bcs chks_ok
                dec actyh,x
chks_ok:        sec
                rts
chks_notup:     lda charblocky        ;The only place where a shift of 2
                clc                   ;chars down is required
                adc #$02
                cmp #$04
                bcc chks_notover1
                sbc #$04
                inc charmapy
chks_notover1:  sta charblocky
                jsr getcharinfo
                and #CI_GROUND
                beq chks_nognd
                lda actyl,x
                clc
                adc #8
                sta actyl,x
                bcc chks_ok2
                inc actyh,x
chks_ok2:       sec
                rts
chks_nognd:     clc
                rts

;Ŀ
;CHECKCLIMB                                                                   
;                                                                             
;Checks if climbing motion is allowed.                                        
;Zeroes Y-speed if obstacle detected. Note: Getcharpos must have              
;been called and checkingpos unaltered. After this the checkingpos. may be    
;in a very weird place :-)                                                    
;                                                                             
;Parameters: -                                                                
;Returns: C=0 no obstacle, C=1 obstacle                                       
;Modifies: A,Y                                                                
;

checkclimb:     lda actsy,x
                beq chkc_ok
                bpl chkc_down
chkc_up:        dec charmapy
                jsr movecharposup1
chkc_down:      jsr getcharinfo
                and #CI_CLIMB
                bne chkc_ok
chkc_stop:      lda #$00
                sta actsy,x
                sec
                rts
chkc_ok:        clc
                rts

;Ŀ
;FACEPLAYER                                                                   
;                                                                             
;Turns actor to face player (Actor 0)                                         
;                                                                             
;Parameters: X:actor number                                                   
;Returns: A:New direction                                                     
;Modifies: A                                                                  
;

faceplayer:     lda actxh,x                     ;Check is player to left or
                cmp actxh                       ;right
                beq fcpl_chklow
                bcs fcpl_left
                bcc fcpl_right
fcpl_chklow:    lda actxl,x
                cmp actxl
                bcs fcpl_left
fcpl_right:     lda #$00
                beq fcpl_facedone
fcpl_left:      lda #$01
fcpl_facedone:  rts

;Ŀ
;FACEPLAYERY                                                                  
;                                                                             
;Returns Y-direction relative to player (0=down 1=up)                         
;                                                                             
;Parameters: X:actor number                                                   
;Returns: A:New direction                                                     
;Modifies: A                                                                  
;

faceplayery:    lda actyl                       ;Use middlepoint of player
                sec
                sbc #21
                sta tempval1
                lda actyh
                sbc #$00
                sta tempval2
                lda actyh,x                     ;Check is player above or
                cmp tempval2                    ;below
                beq fcply_chklow
                bcs fcply_above
                bcc fcply_below
fcply_chklow:   lda actyl,x
                cmp tempval1
                bcs fcply_above
fcply_below:    lda #$00
                beq fcply_facedone
fcply_above:    lda #$01
fcply_facedone: rts

;Ŀ
;GETPLRDISTX                                                                  
;                                                                             
;Gets absolute X distance of actor to player                                  
;                                                                             
;Parameters: -                                                                
;Returns: A:Distance (unsigned)                                               
;Modifies: A                                                                  
;

getplrdistx:    lda actxl,x
                sec
                sbc actxl
                sta tempval1
                lda actxh,x
                sbc actxh
                sta tempval2
                bpl gpd_notneg
gpd_neg:        lda tempval1
                eor #$ff
                clc
                adc #$01
                sta tempval1
                lda tempval2
                eor #$ff
                adc #$00
gpd_notneg:     bne gpd_maxdist
                lda tempval1
                rts
gpd_maxdist:    lda #$ff
                rts

;Ŀ
;GETPLRDISTY                                                                  
;                                                                             
;Gets absolute Y distance of actor to player                                  
;                                                                             
;Parameters: -                                                                
;Returns: A:Distance (unsigned)                                               
;Modifies: A                                                                  
;

getplrdisty:    lda actyl,x
                sec
                sbc actyl
                sta tempval1
                lda actyh,x
                sbc actyh
                sta tempval2
                bpl gpd_notneg
                bmi gpd_neg

;Ŀ
;ACTORCOLLIDE                                                                 
;                                                                             
;Checks collision between two actors                                          
;                                                                             
;Parameters: X,Y:actor numbers                                                
;Returns: Carry=1 if collided                                                 
;Modifies: A                                                                  
;

actorcollide:   stx tempval1                    ;Hahmonumerot talteen
                sty tempval2
                cpy tempval1                    ;Poistutaan jos hahmonumerot
                beq col_quit                    ;samat
                lda actt,x                      ;Tarkistetaan etteivt hahmot
                beq col_quit                    ;ole "tyhji" ja hankitaan
                tax                             ;niiden datastruktuurien
                lda actordatatbllo-1,x          ;osoitteet
                sta srclo
                lda actordatatblhi-1,x
                sta srchi
                lda actt,y
                beq col_quit
                tax
                lda actordatatbllo-1,x
                sta destlo
                lda actordatatblhi-1,x
                sta desthi
                ldx tempval1
                lda actxl,x                     ;Vhennetn X-koordinaatit
                sec                             ;toisistaan
                sbc actxl,y
                sta tempval3
                lda actxh,x
                sbc actxh,y
                bpl col_xnotneg                 ;Tulos negatiivinen?
                lda actxl,y                     ;Jos on negatiivinen, tehdn
                sec                             ;vhennys toisinpin
                sbc actxl,x
                sta tempval3
                lda actxh,y
                sbc actxh,x
col_xnotneg:    bne col_quit                    ;Jos erotuksen hightavu>0,
                ldy #7                          ;hahmot liian kaukana toisistaan
                lda (srclo),y                   ;Lasketaan X-koot yhteen
                clc
                adc (destlo),y
                ldy tempval2
                cmp tempval3                    ;ja verrataan erotukseen
                bcc col_quit                    ;Jos pienempi, ei trmyst
                lda actyl,x                     ;Vhennetn Y-koordinaatit
                sec                             ;toisistaan
                sbc actyl,y
                sta tempval3
                lda actyh,x
                sbc actyh,y
                bmi col_yneg                    ;Tulos negatiivinen?
                bne col_quit                    ;Hightavu>0 = liian kaukana
                ldy #5
                lda (srclo),y                   ;Lasketaan toisen hahmon ala-
                clc                             ;puolen ja toisen ylpuolen
                iny                             ;koot yhteen
                adc (destlo),y
                ldy tempval2
                cmp tempval3                    ;Jos carry pll, trmys
                rts                             ;tapahtui
col_quit:       ldx tempval1
                clc
                rts
col_yneg:       lda actyl,y                     ;Vhennetn Y-koordinaatit
                sec                             ;toisistaan toisinpin
                sbc actyl,x
                sta tempval3
                lda actyh,y
                sbc actyh,x
                bne col_quit                    ;Hightavu>0 = liian kaukana
                ldy #5
                lda (destlo),y                  ;Lasketaan toisen hahmon ala-
                clc                             ;puolen ja toisen ylpuolen
                iny                             ;koot yhteen
                adc (srclo),y
                ldy tempval2                    ;Jos carry pll, trmys
                cmp tempval3                    ;tapahtui
                rts

;Ŀ
;ACTBLTCOLLIDE                                                                
;                                                                             
;Checks collision between an actor and a bullet                               
;                                                                             
;Parameters: X:actor number                                                   
;            Y:bullet number                                                  
;Returns: Carry=1 if collided                                                 
;Modifies: A                                                                  
;

actbltcollide:  stx tempval1                    ;Hahmonumerot talteen
                sty tempval2
                lda actt,x                      ;Tarkistetaan etteivt hahmot
                beq abc_quit                    ;ole "tyhji" ja hankitaan
                tax                             ;niiden datastruktuurien
                lda actordatatbllo-1,x          ;osoitteet
                sta srclo
                lda actordatatblhi-1,x
                sta srchi
                lda bltt,y
                beq abc_quit
                ldx tempval1
                lda actxl,x                     ;Vhennetn X-koordinaatit
                sec                             ;toisistaan
                sbc bltxl,y
                sta tempval3
                lda actxh,x
                sbc bltxh,y
                bpl abc_xnotneg                 ;Tulos negatiivinen?
                lda bltxl,y                     ;Jos on negatiivinen, tehdn
                sec                             ;vhennys toisinpin
                sbc actxl,x
                sta tempval3
                lda bltxh,y
                sbc actxh,x
abc_xnotneg:    bne abc_quit                    ;Jos erotuksen hightavu>0,
                ldy #7                          ;hahmot liian kaukana toisistaan
                lda (srclo),y                   ;Otetaan hahmon X-koko
                ldy tempval2
                cmp tempval3                    ;ja verrataan erotukseen
                bcc abc_quit                    ;Jos pienempi, ei trmyst
                lda actyl,x                     ;Vhennetn Y-koordinaatit
                sec                             ;toisistaan
                sbc bltyl,y
                sta tempval3
                lda actyh,x
                sbc bltyh,y
                bmi abc_yneg                    ;Tulos negatiivinen?
                bne abc_quit                    ;Hightavu>0 = liian kaukana
                ldy #5
                lda (srclo),y
                ldy tempval2
                cmp tempval3                    ;Carry osoittaa nyt trmyksen
                rts
abc_quit:       ldx tempval1
                clc
                rts
abc_yneg:       lda bltyl,y                     ;Vhennetn Y-koordinaatit
                sec                             ;toisistaan toisinpin
                sbc actyl,x
                sta tempval3
                lda bltyh,y
                sbc actyh,x
                bne abc_quit                    ;Hightavu>0 = liian kaukana
                ldy #6
                lda (srclo),y
                ldy tempval2
                cmp tempval3
                rts

