;ͻ
;COVERT BITOPS autostarter                                                    
;Programmed in 2/2002                                                         
;ͼ

                processor 6502

bitcode         = $fb
strlen          = $fc
destl           = $fd
desth           = $fe
bitsleft        = $ff

loadercode      = $0400
loaderstart     = $0620

chkin           = $ffc6
setlfs          = $ffba
setnam          = $ffbd
chrin           = $ffcf
close           = $ffc3
open            = $ffc0
clrchn          = $ffcc
restor          = $ff8a
clall           = $ffe7

fa              = $ba
status          = $90

                org $032a

                rorg 2049

                dc.b $0b,$08           ;Address of next BASIC instruction
                dc.w codestart         ;Line number (CLALL vector)
                dc.b $9e               ;SYS-token
                dc.b $32,$30,$36,$31   ;2061 in ASCII
                dc.b $00,$00,$00       ;BASIC program end

                ldx #$00
copyloop:       lda relocatedcodestart,x
                sta codestart,x
                inx
                cpx #codeend-codestart
                bcc copyloop
                jmp codestart_noauto

relocatedcodestart:
                rend

codestart:      jsr restor
                jsr clall
codestart_noauto:
                lda #$06
                ldx #<filename
                ldy #>filename
                jsr setnam
                ldx fa
                bne devicenumok
                ldx #$08
devicenumok:    lda #$02
                ldy #$00                        ;Open for load
                sty $d020                       ;Blank screen
                sty $d021
                sty $d011
                jsr setlfs
                jsr open
                ldx #$02                        ;Logical file number 2
                jsr chkin
                ldy #$00
                sty bitsleft
                lda #<loadercode
                sta destl
                lda #>loadercode
                sta desth
depackloop:     lda bitsleft                    ;Time for new bitcode?
                bne dp_nonew
                jsr dp_get
                sta bitcode
                lda #$08                        ;Eight bits now...
                sta bitsleft
dp_nonew:       dec bitsleft
                lsr bitcode                     ;A repeat string or an ordinary
                bcs dp_string                   ;byte?
                jsr dp_get
                jsr dp_put
                jmp depackloop
dp_string:      jsr dp_get                      ;Get string position
                sta dp_copystrpos+1
                jsr dp_get                      ;And length
                sta strlen
dp_copystring:  dec desth
dp_copystrpos:  ldy #$00
                lda (destl),y
                inc desth
                ldy #$00
                jsr dp_put
                dec strlen
                bne dp_copystring
                jmp depackloop

dp_get:         ldx status                      ;Check status for EOF
                bne dp_ready
                jsr chrin
                rts
dp_ready:       lda #$02
                jsr close
                jmp loaderstart

dp_put:         sta (destl),y
                inc destl
                bne dp_put2
                inc desth
dp_put2:        rts

filename:       dc.b "LOADER"

codeend:

