;ͻ
;Metal Warrior 2 Control routines                                             
;Copied from MW1 in 9/1999!                                                   
;ͼ

JOY_UP          = 1
JOY_DOWN        = 2
JOY_LEFT        = 4
JOY_RIGHT       = 8
JOY_FIRE        = 16

KEY_DEL         = 0
KEY_CR          = 1
KEY_CURSLR      = 2
KEY_F7          = 3
KEY_F1          = 4
KEY_F3          = 5
KEY_F5          = 6
KEY_CURSUD      = 7
KEY_3           = 8
KEY_W           = 9
KEY_A           = 10
KEY_4           = 11
KEY_Z           = 12
KEY_S           = 13
KEY_E           = 14
KEY_SHIFT1      = 15
KEY_5           = 16
KEY_R           = 17
KEY_D           = 18
KEY_6           = 19
KEY_C           = 20
KEY_F           = 21
KEY_T           = 22
KEY_X           = 23
KEY_7           = 24
KEY_Y           = 25
KEY_G           = 26
KEY_8           = 27
KEY_B           = 28
KEY_H           = 29
KEY_U           = 30
KEY_V           = 31
KEY_9           = 32
KEY_I           = 33
KEY_J           = 34
KEY_0           = 35
KEY_M           = 36
KEY_K           = 37
KEY_O           = 38
KEY_N           = 39
KEY_PLUS        = 40
KEY_P           = 41
KEY_L           = 42
KEY_MINUS       = 43
KEY_PISTE       = 44
KEY_2PISTE      = 45
KEY_MIUMAU      = 46
KEY_PILKKU      = 47
KEY_PUNTA       = 48
KEY_TAHTI       = 49
KEY_PUOLIPISTE  = 50
KEY_HOME        = 51
KEY_SHIFT2      = 52
KEY_ON          = 53
KEY_ARROWU      = 54
KEY_SLASH       = 55
KEY_1           = 56
KEY_ARROWL      = 57
KEY_CTRL        = 58
KEY_2           = 59
KEY_SPACE       = 60
KEY_CBM         = 61
KEY_Q           = 62
KEY_RUNSTOP     = 63



CONTROL_START:

;Ŀ
;INITCONTROLS                                                                 
;                                                                             
;Initializes control zeropage variables.                                      
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A                                                                  
;

initcontrols:   lda #$00
                sta joystick
                sta prevjoy
                lda #$ff
                sta keyval
                sta lastkey
                rts

;Ŀ
;GETCONTROLS                                                                  
;                                                                             
;Gets joystick 2 & keyboard controls                                          
;                                                                             
;Parameters: -                                                                
;Returns: joystick, keyval, lastkey, (prevjoy)                                
;Modifies: A,X,Y                                                              
;

getcontrols:    lda #$ff
                sta $dc00
                lda joystick
                sta prevjoy
                lda $dc00
                eor #$ff
                sta joystick

;Ŀ
;SCANKEYS                                                                     
;                                                                             
;Scans the keyboard.                                                          
;This routine has been ripped from Jukka Tapanimki :-)                       
;                                                                             
;Parameters: -                                                                
;Returns: keyval, lastkey                                                     
;Modifies: A,X,Y                                                              
;

scankeys:       lda #$ff
                sta keyval
                ldy #$07
sk_rowloop:     lda rowbit,y
                sta $dc00
                ldx $dc01
                cpx #$ff
                bne sk_keyfound
                dey
                bpl sk_rowloop
                lda #$ff
                sta lastkey
                rts
sk_keyfound:    sty keytemp
                ldy #7
sk_getcol:      txa
                and colbit,y
                beq sk_colfound
                dey
                bpl sk_getcol
sk_colfound:    ldx keytemp
                tya
                clc
                adc rowval,x
                cmp lastkey
                beq sk_samekey
                sta keyval
                sta lastkey
sk_samekey:     rts



;Ŀ
;GETFIRECLICK                                                                 
;                                                                             
;Checks for short pressing of fire button                                     
;                                                                             
;Parameters: -                                                                
;Returns: Carry=1: button pressed                                             
;Modifies: A                                                                  
;

getfireclick:   lda joystick
                and #JOY_FIRE
                beq gfc_not
                lda prevjoy
                and #JOY_FIRE
                bne gfc_not
                sec
                rts
gfc_not:        clc
                rts

