;ͻ
;Metal Warrior 2 - Enemy routines                                             
;Started in 10/1999!                                                          
;ͼ

ENEMYDEADTIME   = 15
MAXEXPL         = 4

ENEMY_START:

ar_fistman:     lda acthp,x
                bne arfm_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_FISTMANDEAD
                jmp enemydeath_fly
arfm_notdead:   lda actcnt,x
                bne arfm_nochng
                jsr arfm_getspeed
arfm_nochng:    dec actcnt,x
                lda actf,x                      ;Punch animation?
                cmp #$04
                bcc arfm_walkanim
                lda #$02
                jsr animdelay
                bcc arfm_punchdone
                inc actf,x
                lda actf,x
                cmp #$06
                bcc arfm_punchdone
                lda #$00
                sta actf,x
                jmp arfm_getspeed
arfm_punchdone: lda #$04
                jsr brakeactorx
                jmp arfm_noanim
arfm_walkanim:  jsr getplrdistx
                cmp #$18                ;X distance less than 24?
                bcs arfm_nopunch
                jsr getplrdisty
                cmp #$20                ;Y distance less than 32?
                bcs arfm_nopunch
                jsr faceplayer
                cmp actd,x              ;Facing the right way?
                bne arfm_nopunch
                jsr random              ;Random decision for punch
                and #$03
                bne arfm_nopunch
                lda #$04
                sta actf,x
                lda #$00
                sta actfd,x
                lda #WPN_FISTS          ;Perform attack
                ldy #16
                jsr enemyshoot
                jmp arfm_punchdone
arfm_nopunch:   jsr additiveanim
                and #$03
                sta actf,x
arfm_noanim:    lda actxl,x
                sta srclo
                lda actxh,x
                sta srchi
                jsr getcharpos
                jsr checkobst
                bcs arfm_stop
                jsr moveactorx
                jsr checkstairs
                bcc arfm_stop
                rts
arfm_stop:      lda srclo
                sta actxl,x
                lda srchi
                sta actxh,x
arfm_getspeed:  jsr faceplayer
                sta actd,x
                jsr random
                and #$1f
                adc #$08                        ;Doesn't matter if C=0 or 1
                sta actcnt,x
                jsr random
                and #$03
                asl
                clc
                adc actd,x
                tay
                lda arfm_speedtbl,y
                sta actsx,x
                rts
arfm_speedtbl:  dc.b 2*8,-2*8,2*8,-2*8,1*8,-1*8,-1*8,1*8

ar_gunman:      lda acthp,x
                bne argm_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_GUNMANDEAD
                jmp enemydeath_fly
argm_notdead:   jsr getplrdisty
                cmp #$18                ;Y distance less than 24?
                bcs argm_noattack
                jsr faceplayer          ;Facing the right way?
                cmp actd,x
                beq argm_rightdir
                jsr random              ;If wrong way, then reverse direction
                and #$1f                ;at certain probability
                bne argm_noattack
                jsr reverseactor
                jmp argm_noattack
argm_rightdir:  jsr random              ;Random decision for shoot
                and #$0f
                bne argm_noattack
                lda #WPN_PISTOL          ;Perform attack
                ldy #16
                jsr enemyshoot
                lda #$10                ;Make shoot delay a little longer
                sta actsd,x
argm_noattack:  lda actbits,x
                beq argm_nojump
                lda #4
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr getcharpos
                jsr landingcheck
                bcs argm_jumpdone
                jsr checkobst2                  ;In jumps obstacles should
                bcc argm_noreverse1
                jsr reverseactor
argm_noreverse1:jsr moveactorx                  ;be checked one char lower
                jsr getcharpos
                jsr landingcheck
argm_jumpdone:  rts
argm_nojump:    lda actd,x
                bne argm_accleft
                lda #4
                ldy #4*8
                bne argm_accdone
argm_accleft:   lda #-4
                ldy #-4*8
argm_accdone:   jsr accactorx
                lda #$02
                jsr fourframeanim
argm_animdone:  jsr getcharpos
                jsr checkobst
                bcc argm_noreverse2
                jsr reverseactor
argm_noreverse2:jsr moveactorx
                jsr checkstairs
                bcs argm_nojump2
                lda #AB_JUMP
                sta actbits,x
                lda #-6*8
                sta actsy,x
                lda #4
                sta actf,x
argm_nojump2:   rts

ar_shotgunman:  lda acthp,x
                bne arsg_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_SHOTGUNDEAD
                jmp enemydeath_fly
arsg_notdead:   lda actcnt,x            ;Waiting for attack?
                beq arsg_nowait
                dec actcnt,x
                bne arsg_brake
                ldy #16
                lda #WPN_SHOTGUN
                jsr enemyshoot
arsg_brake:     lda #4
                jsr brakeactorx
                jmp arsg_animdone
arsg_nowait:    jsr getplrdisty
                cmp #$18                ;Y distance less than 24?
                bcs arsg_noattack
                jsr random              ;Random decision for shoot
                and #$1f
                bne arsg_noattack
                lda #$0c                ;Initiate a small delay before shooting
                sta actcnt,x
                lda #$00
                sta actf,x
                jsr faceplayer          ;Turn to face player when shooting
                sta actd,x
                jmp arsg_animdone
arsg_noattack:  ldy actd,x
                lda arsg_xtbl,y
                sta actsx,x
                lda #$03
                jsr fourframeanim
arsg_animdone:
enemyxmotion:   lda actxl,x
                sta srclo
                lda actxh,x
                sta srchi
                jsr getcharpos
                jsr checkobst
                bcs enemyx_stop
                jsr moveactorx
                jsr checkstairs
                bcc enemyx_stop
                rts
enemyx_stop:    lda srclo
                sta actxl,x
                lda srchi
                sta actxh,x
                lda #$00
                sta actsx,x
                jmp reverseactor
arsg_xtbl:      dc.b 2*8,-2*8

ar_motorist:    lda acthp,x
                bne armo_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_QUADEXPLOSION
                jmp enemydeath_expl
armo_notdead:   jsr faceplayer
                cmp actd,x
                bne armo_nocoll
                lda #21                         ;Check collision only to the
                sta ad_motorist+5               ;bike :-)
                lda #$02                        ;Check collision with player
                jsr enemycollide
                lda #35                         ;Then change size back to
                sta ad_motorist+5               ;normal
armo_nocoll:    lda actd,x
                bne armo_accleft
                lda #3
                ldy #6*8
                bne armo_acccommon
armo_accleft:   lda #-3
                ldy #-6*8
armo_acccommon: jsr accactorx
                jmp enemyxmotion

ar_innocent:    ldy actd,x
                lda arsg_xtbl,y
                sta actsx,x
                lda #$03
                jsr fourframeanim
arin_animdone:  jmp enemyxmotion

ar_eagle:       lda acthp,x
                bne area_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
area_notdead:   lda actcnt,x                    ;Eagle will hit only once
                bne area_nocoll
                lda #$04                        ;Check collision with player
                jsr enemycollide
                bcc area_nocoll
                inc actcnt,x
area_nocoll:    lda actsd                       ;Eagle is afraid of gunfire
                bne area_accup
                jsr faceplayer                  ;Has eagle passed player?
                cmp actd,x
                bne area_accup
                jsr faceplayery                 ;If not, seek towards
                bne area_accup
area_accdown:   lda #$00                        ;Lock wings in place
                sta actf,x
                lda #4
                ldy #3*8
                jsr accactory
                jmp area_accydone
area_accup:     lda #-4
                ldy #-2*8
                jsr accactory
area_anim:      lda #$04                        ;Flapping animation if going
                jsr fourframeanim
area_accydone:  lda actd,x
                bne area_left
area_right:     lda #4
                ldy #6*8
                bne area_accxdone
area_left:      lda #-4
                ldy #-6*8
area_accxdone:  jsr accactorx
                jsr getcharpos
                jsr checkobsty
                jsr moveactory
                jsr checkobst2
                bcs area_reverse
                jmp moveactorx
area_reverse:   jmp reverseactor

ar_veteran:     lda acthp,x
                bne arve_notdead
                ldy #ITEM_FLAME                 ;Veteran leaves either
                jsr random                      ;flame thrower or grenades
                and #$01
                beq ar_powerup1
                ldy #ITEM_GRENADES
ar_powerup1:    sty veteranreward+3
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_VETERANDEAD
                jmp enemydeath_fly
arve_notdead:   lda actf,x            ;Waiting after a grenadethrow?
                cmp #$04
                bne arve_nowait
                lda #$04
                jsr animdelay
                bcc arve_brake
                lda #$00
                sta actf,x
arve_brake:     lda #$04
                jsr brakeactorx
                jmp arve_animdone
arve_nowait:    jsr getplrdisty
                cmp #$18                ;Y distance less than 24?
                bcs arve_nonewattack
                jsr random              ;Random decision for attack
                and #$3f
                cmp #$3d
                bcc arve_nonewattack
                beq arve_grenade
                ldy actcnt,x            ;If flame sequence already going on
                bne arve_nonewattack    ;then wait
                lda #$0a                ;Initiate flame sequence for 10 frames!
                sta actcnt,x
                jmp arve_nonewattack
arve_grenade:   ldy #$08
                lda #WPN_GRENADES
                jsr enemyshoot
                bcc arve_nonewattack
                lda #$00                ;Init throw anim. only if attack
                sta actfd,x             ;successful
                sta actcnt,x
                lda #$04
                sta actf,x
                jmp arve_animdone
arve_nonewattack:lda actcnt,x
                beq arve_noflame
                dec actcnt,x
                ldy #16
                lda #WPN_FLAME
                jsr enemyshoot
arve_noflame:   ldy actd,x
                lda arsg_xtbl,y
                sta actsx,x
                lda #$03
                jsr fourframeanim
arve_animdone:  jmp enemyxmotion

ar_rat:         lda acthp,x
                bne arrt_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arrt_notdead:   lda actbits,x
                beq arrt_nojump
                lda actf,x
                beq arrt_noattack
                lda #$04                        ;Rat's attack is the jump
                jsr enemycollide                ;when it's in the attack frame
                bcc arrt_noattack               ;(1)
                dec actf,x
arrt_noattack:  ldy actd,x
                lda arrt_xtbl,y
                sta actsx,x
                lda #5
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr getcharpos
                jsr landingcheck
                bcs arrt_jumpdone
                jsr checkobst2                  ;In jumps obstacles should
                bcc arrt_noreverse1
                jsr reverseactor
arrt_noreverse1:jsr moveactorx                  ;be checked one char lower
                jsr getcharpos
                jsr landingcheck
arrt_jumpdone:  rts
arrt_nojump:    jsr faceplayer                  ;Facing the right way?
                cmp actd,x
                bne arrt_nonewjump
                jsr getplrdistx
                cmp #$28                        ;Sufficiently close to player?
                bcs arrt_nonewjump
                cmp #$20                        ;But not too close?
                bcc arrt_nonewjump
                jsr getplrdisty
                cmp #$18
                bcs arrt_nonewjump
                lda #AB_JUMP
                sta actbits,x
                lda #-6*8
                sta actsy,x
                lda #1
                sta actf,x
                rts
arrt_nonewjump: jsr random                      ;Acceleration or braking?
                and #$03
                bne arrt_brake
                ldy actd,x
                lda arrt_xtbl,y
                sta actsx,x
                jmp arrt_accdone
arrt_brake:     lda #$04
                jsr brakeactorx
arrt_accdone:   lda actsx,x
                bne arrt_anim
                sta actf,x
                beq arrt_noanim
arrt_anim:      lda #$03
                jsr animdelay
                bcc arrt_noanim
                lda actf,x
                eor #$01
                sta actf,x
arrt_noanim:    jmp enemyxmotion
arrt_xtbl:      dc.b 4*8,-4*8

ar_worm:        lda acthp,x
                bne arwo_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arwo_notdead:   lda #$02                        ;Check collision with player
                jsr enemycollide
                lda actd,x
                beq arwo_right
arwo_left:      lda #-4
                ldy #-4*8
                bne arwo_acccommon
arwo_right:     lda #4
                ldy #4*8
arwo_acccommon: jsr accactorx
                lda #$02
                jsr fourframeanim
arwo_animdone:  jmp enemyxmotion

ar_rock:        lda acthp,x
                bne arro_noexpl
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arro_noexpl:    lda #$08                        ;Check collision with player
                jsr enemycollide
                bcs arro_explode
                lda actsx,x                     ;No speed determined yet?
                bne arro_xspdok
                ldy actd,x
                lda arfm_speedtbl+4,y
                sta actsx,x
arro_xspdok:    lda #4                          ;Perform Y-acceleration
                ldy #8*8
                jsr accactory
                jsr moveactorx
                jsr moveactory
                lda actsy,x                     ;Is Y-speed at maximum?
                cmp #8*8
                bne arro_nolanding
                jsr getcharpos
                jsr getcharinfo
                and #CI_GROUND                  ;Hit the ground?
                beq arro_nolanding
                lda #FX_DEATH                   ;Hmm...weird sound :-)
                jsr playfx
                lda actyl,x
                and #$f8
                sta actyl,x
                lda #-6*8                       ;Reset Y-speed
                sta actsy,x
                inc actf,x                      ;Make the rock smaller
                lda actf,x
                cmp #$02                        ;Should it explode?
                bcc arro_spawnrock
arro_explode:   lda #ACT_EXPLOSION
                jmp enemyexpl_noscore
arro_spawnrock: ldy #AN_FIRSTENEMY              ;Spawn second rock if possible
                lda #AN_LASTENEMY+1
                jsr getfreeactor
                bcc arro_setxspeed
                lda #ACT_ROCK                   ;Set type & frame & hitpoints
                sta actt,y
                lda #$01
                sta actf,y
                lda acthp,x
                sta acthp,y
                jsr copycoords
                lda #-5*8                       ;Make the other go a bit lower
                sta actsy,y
                jsr arro_setxspeed
                lda actsx,x
                sta actsx,y
arro_setxspeed: stx tempval1
                jsr random
                and #$07
                tax
                lda arro_xtbl,x
                ldx tempval1
                sta actsx,x
arro_nolanding: rts
arro_xtbl:      dc.b 1*8,2*8,3*8,4*8,-1*8,-2*8,-3*8,-4*8

ar_pig:         lda acthp,x
                bne arpi_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_PIGDEAD
                jmp enemydeath_fly
arpi_notdead:   lda actbits,x                   ;Jumping?
                bne arpi_jump
                lda actcnt,x                    ;Time to jump?
                bne arpi_waitjump
arpi_initjump:  lda #AB_JUMP
                sta actbits,x
                jsr random
                and #$03
                asl
                asl
                asl                             ;Carry=0
                sbc #56-1
                sta actsy,x
                jsr random
                and #$0f                        ;Set delay for next jump
                clc
                adc #$04
                sta actcnt,x
                lda #$02                        ;Set jumping frame
                sta actf,x
                lda #FX_JUMP
                jmp playfx
arpi_jump:      lda #$02                        ;Check collision with player
                jsr enemycollide
                ldy actd,x
                lda arrt_xtbl,y
                sta actsx,x
                lda #4
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr getcharpos
                jsr landingcheck
                bcs arpi_jumpdone
                jsr checkobst2                  ;In jumps obstacles should
                bcc arpi_noreverse1
                jsr reverseactor
arpi_noreverse1:jsr moveactorx                  ;be checked one char lower
                jsr getcharpos
                jmp landingcheck
arpi_waitjump:  lda actcnt,x                    ;Pig's breathing animation
                and #$04
                lsr
                lsr
                sta actf,x
                dec actcnt,x
arpi_jumpdone:  rts

ar_spider:      lda acthp,x
                bne arsp_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arsp_notdead:   lda #$04                        ;Check collision with player
                jsr enemycollide
                lda actd,x
                beq arsp_right
arsp_left:      lda #-4
                ldy #-4*8
                bne arsp_acccommon
arsp_right:     lda #4
                ldy #4*8
arsp_acccommon: jsr accactorx
                lda #$01
                jsr fourframeanim
arsp_animdone:  jmp enemyxmotion

ar_slime:       lda acthp,x
                bne arsl_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arsl_notdead:   lda #$02                        ;Check collision with player
                jsr enemycollide
                lda actbits,x                   ;Jumping?
                bne arsl_jump
                lda actcnt,x                    ;Time to jump?
                bne arsl_waitjump
arsl_initjump:  lda #AB_JUMP
                sta actbits,x
                jsr random
                and #$03
                asl
                asl
                asl                             ;Carry=0
                sbc #64-1
                sta actsy,x
                jsr random
                and #$07                        ;Set delay for next jump
                sta actcnt,x
                jsr random                      ;Set direction for this jump
                and #$01
                sta actd,x
                rts
arsl_jump:      jsr random                      ;Random animation when
                and #$01                        ;jumping
                clc
                adc #$04
                sta actf,x
                ldy actd,x
                lda arsl_xtbl,y
                sta actsx,x
                lda #6
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr getcharpos
                jsr landingcheck
                bcs arsl_jumpdone
                jsr checkobst2                  ;In jumps obstacles should
                bcc arsl_noreverse1
                jsr reverseactor
arsl_noreverse1:jsr moveactorx                  ;be checked one char lower
                jsr getcharpos
                jmp landingcheck
arsl_waitjump:  lda actcnt,x                    ;Slime's waiting animation
                lsr
                and #$03
                sta actf,x
                dec actcnt,x
arsl_jumpdone:  rts
arsl_xtbl:      dc.b 5*8,-5*8

ar_fatworm:     lda acthp,x
                bne arfw_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arfw_notdead:   lda #$03                        ;Check collision with player
                jsr enemycollide
                lda actd,x
                beq arfw_right
arfw_left:      lda #-1
                ldy #-5*8
                bne arfw_acccommon
arfw_right:     lda #1
                ldy #5*8
arfw_acccommon: jsr accactorx
                lda #$01
                jsr fourframeanim
arfw_animdone:  jsr faceplayer
                cmp actd,x
                bne arfw_nofire
                jsr getplrdistx
                cmp #64
                bcs arfw_nofire
                jsr getplrdisty
                cmp #16
                bcs arfw_nofire
                ldy #10
                lda #WPN_FLAME
                jsr enemyshoot
                lda #$04
                sta actsd,x
arfw_nofire:    jmp enemyxmotion

ar_mosquito:    lda acthp,x
                bne arms_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arms_notdead:   lda #$03                        ;Check collision with player
                jsr enemycollide
                lda actcnt,x                    ;New direction?
                bne arms_nodir
                jsr random                      ;Time for new dir.
                and #$07
                clc
                adc #$02
                sta actcnt,x
                jsr random
                and #$07
                tay
                lda arro_xtbl,y
                sta actsy,x
                ldy actd,x
                lda arsl_xtbl,y
                sta actsx,x
arms_nodir:     dec actcnt,x
                lda actf,x                      ;Flapping of wings
                eor #$01
                sta actf,x
                jsr getcharpos                  ;Movement is simple :-)
                jsr checkobsty
                jsr moveactory
                jsr checkobst2
                bcc arms_noreverse
                jmp reverseactor
arms_noreverse: jmp moveactorx

ar_lizard:      lda acthp,x
                bne arli_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_DBLEXPLOSION
                jmp enemydeath_expl
arli_notdead:   lda actd,x
                beq arli_right
arli_left:      lda #-2
                ldy #-4*8
                bne arli_acccommon
arli_right:     lda #2
                ldy #4*8
arli_acccommon: jsr accactorx
                lda #$02
                jsr fourframeanim
arli_animdone:  jsr faceplayer
                cmp actd,x
                bne arli_reverse
                jsr getplrdistx
                cmp #80
                bcs arli_nofire
                jsr getplrdisty
                cmp #16
                bcs arli_nofire
                ldy #12
                lda #WPN_FLAME
                jsr enemyshoot
                bcc arli_nofire
                lda #$04
                sta actsd,x
arli_nofire:    jmp enemyxmotion
arli_reverse:   jsr random                      ;They will occasionally turn
                and #$3f                        ;to chase the player
                bne arli_nofire
                jsr reverseactor
                jmp enemyxmotion


ar_gunup:       lda #WPN_MULTI1
                sta argu_add+1
                lda #$01
                sta argu_ycheck+1
                jmp ar_guncommon
ar_gundown:     lda #WPN_MULTI2
                sta argu_add+1
                lda #$00
                sta argu_ycheck+1
                jmp ar_guncommon

ar_guncommon:   lda acthp,x
                bne argu_notdead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
argu_notdead:   jsr faceplayery
argu_ycheck:    cmp #$00
                bne argu_noaction
                jsr getplrdistx
                cmp #128
                bcs argu_noaction
                lda actcnt,x
                bne argu_wait
                jsr random
                and #$03
                cmp #$03
                bne argu_not3
                lda #$00
argu_not3:      clc
argu_add:       adc #WPN_MULTI1
                ldy #$00
                jsr enemyshoot
                ldy #$04
                inc actfd,x
                lda actfd,x
                and #$07
                bne argu_smalldelay
                ldy #$20
argu_smalldelay:tya
                sta actcnt,x
argu_wait:      dec actcnt,x
argu_noaction:  rts

ar_mine:        lda acthp,x
                bne armn_notdead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
armn_notdead:   ldy #$00                        ;Collision will blow up
                jsr actorcollide                ;immediately
                bcc armn_nocoll
                jmp armn_explode
armn_nocoll:    lda actcnt,x                    ;Mine armed?
                bne armn_countdown
                jsr getplrdistx
                cmp #32
                bcs armn_notnear
                jsr getplrdisty
                cmp #32
                bcs armn_notnear
armn_initcount: lda #20
                sta actcnt,x
armn_countdown: lda actcnt,x                    ;Flashing light animation
                pha
                and #$01
                sta actf,x
                pla
                and #$03
                bne armn_nosound
                lda #FX_SELECT
                jsr playfx
armn_nosound:   dec actcnt,x
                beq armn_explode
armn_notnear:   rts
armn_explode:   lda #ACT_EXPLOSION
                jsr enemyexpl_noscore
                stx grc_restx+1
                txa                             ;Move actornumber to Y
                tay
                jmp grc_player                  ;Perform possible expl.damage

ar_sidegun:     lda acthp,x
                bne arsi_notdead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arsi_notdead:   ldy actf,x
                lda arsi_delaytbl,y
                jsr animdelay
                bcc arsi_noframe
                tya
                eor #$01
                sta actf,x
                bne arsi_noframe
                lda actd,x
                eor #$01
                sta actd,x
arsi_noframe:   lda actf,x
                bne arsi_noaction
                jsr faceplayer
                cmp actd,x
                bne arsi_noaction
                jsr faceplayery             ;Player must be beneath gun
                tay                         ;and not too far away
                bne arsi_noaction
                jsr getplrdisty
                cmp #$31
                bcs arsi_noaction
                lda #WPN_LASER
                ldy #$10
                jsr enemyshoot
arsi_noaction:  rts
arsi_delaytbl:  dc.b 24,4

ar_biomech1:    lda acthp,x
                bne arm1_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_DBLEXPLOSION
                jmp enemydeath_expl
arm1_notdead:   lda actcnt,x                    ;Shooting?
                beq arm1_nowait
                dec actcnt,x
                lda #$04
                jsr brakeactorx
                ldy #$00                        ;Assume: Shooting straight
                jsr getplrdisty                 ;Get Y distance
                cmp #$00                        ;If zero, check ducking
                beq arm1_duckcheck
                jsr faceplayery
                beq arm1_shootdown
arm1_shootup:   ldy #$01
                bne arm1_shootok
arm1_duckcheck: lda actt
                cmp #ACT_PLAYERDUCK
                bne arm1_shootok
arm1_shootdown: ldy #$02
arm1_shootok:   lda arm1_frametbl,y
                sta actf,x
                lda arm1_wpntbl,y
                sta arm1_yspd+1
                lda #WPN_LASER
                ldy #8
                jsr enemyshoot
                bcc arm1_animdone
arm1_yspd:      lda #$00
                sta bltsy,y
                jmp arm1_animdone
arm1_nowait:    jsr getplrdistx
                cmp #$a0                ;X distance less than 160?
                bcs arm1_noattack
                cmp #$10                ;But more than 16
                bcc arm1_noattack
                jsr random              ;Random decision for attack
                and #$3f
                cmp #$3f
                bcc arm1_noattack
                jsr faceplayer          ;Turn to face player
                sta actd,x
                lda #$0c                ;Attack for 12 frames!
                sta actcnt,x
arm1_noattack:  ldy actd,x
                lda arsg_xtbl,y
                sta actsx,x
                lda #$03
                jsr fourframeanim
arm1_animdone:  jmp enemyxmotion
arm1_frametbl:  dc.b 0,4,5
arm1_wpntbl:    dc.b 0,-8,8


ar_biomech2:    lda acthp,x
                bne arm2_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_DBLEXPLOSION
                jmp enemydeath_expl
arm2_notdead:   jsr getplrdisty
                cmp #$18                ;Y distance less than 24?
                bcs arm2_noattack
                jsr faceplayer          ;Facing the right way?
                cmp actd,x
                beq arm2_rightdir
                jsr random              ;If wrong way, then reverse direction
                and #$1f                ;at certain probability
                bne arm2_noattack
                jsr reverseactor
                jmp arm2_noattack
arm2_rightdir:  jsr random              ;Random decision for shoot
                and #$0f
                bne arm2_noattack
                lda #WPN_LASER          ;Perform attack
                ldy #0
                jsr enemyshoot
                lda #$10                ;Make shoot delay a little longer
                sta actsd,x
arm2_noattack:  lda actd,x
                bne arm2_accleft
                lda #2
                ldy #4*8
                jsr accactorx
                jmp arm2_accdone
arm2_accleft:   lda #-2
                ldy #-4*8
                jsr accactorx
arm2_accdone:   lda actbits,x
                beq arm2_nojump
                lda #4
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr getcharpos
                jsr landingcheck
                bcs arm2_jumpdone
                jsr checkobst2                  ;In jumps obstacles should
                jsr moveactorx                  ;be checked one char lower
                jsr getcharpos
                jsr landingcheck
arm2_jumpdone:  rts
arm2_nojump:    jsr additiveanim
                lsr
                sta actf,x
arm2_animdone:  jsr getcharpos
                jsr checkobst
                bcc arm2_noreverse2
                dec charmapy                    ;If there is free space one
                jsr getcharinfo                 ;block upwards, do jump
                and #CI_OBSTACLE
                beq arm2_jump
                jsr reverseactor
arm2_noreverse2:jsr moveactorx
                jsr checkstairs
                bcs arm2_nojump2
arm2_jump:      lda #AB_JUMP
                sta actbits,x
                lda #-7*8
                sta actsy,x
                lda #$01
                sta actf,x
arm2_nojump2:   rts

ar_droid:       lda acthp,x
                bne ardr_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
ardr_notdead:   lda #EXPLOSIONDAMAGE            ;Check collision with player
                jsr enemycollide
                bcc ardr_nocoll
                jmp arro_explode
ardr_nocoll:    jsr faceplayery                 ;Check direction to player
                bne ardr_accup                  ;in Y-direction
                jsr getplrdisty
                cmp #$20
                bcs ardr_accdown
ardr_accup:     lda #-3
                ldy #-3*8
                bne ardr_accydone
ardr_accdown:   lda #3
                ldy #3*8
ardr_accydone:  jsr accactory
                jsr faceplayer
                bne ardr_accleft
ardr_accright:  lda #2
                ldy #5*8
                bne ardr_accxdone
ardr_accleft:   lda #-2
                ldy #-5*8
ardr_accxdone:  jsr accactorx
                lda #$01
                jsr fourframeanim
                jsr getcharpos
                jsr checkobsty
                jsr moveactory
                jsr checkobst2
                jmp moveactorx

ar_smalltank:   lda acthp,x
                bne arst_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_EXPLOSION
                jmp enemydeath_expl
arst_notdead:   lda actd,x
                beq arst_right
arst_left:      lda #-3
                ldy #-4*8
                bne arst_acccommon
arst_right:     lda #3
                ldy #4*8
arst_acccommon: jsr accactorx
                jsr additiveanim
                and #$01
                sta actf,x
                jsr faceplayer
                cmp actd,x
                bne arst_reverse
                jsr random
                and #$3f
                cmp #$3c
                bcc arst_nofire
                jsr getplrdistx
                cmp #$70
                bcs arst_nofire
                jsr getplrdisty
                cmp #$10
                bcs arst_nofire
                ldy #$08
                lda #WPN_LASER
                jsr enemyshoot
arst_nofire:    jmp enemyxmotion
arst_reverse:   jsr random                      ;They will occasionally turn
                and #$3f                        ;to chase the player
                bne arst_nofire
                jsr reverseactor
                jmp enemyxmotion

ar_bigtank:     lda acthp,x
                bne arbt_notdead
                jsr powerup                     ;Leave a powerup when dead
                lda #ACT_QUADEXPLOSION
                jmp enemydeath_expl
arbt_notdead:   jsr faceplayer
                cmp actd,x
                bne arbt_nocoll
                lda #$03
                jsr enemycollide
arbt_nocoll:    lda actd,x
                beq arbt_right
arbt_left:      lda #-2
                ldy #-3*8
                bne arbt_acccommon
arbt_right:     lda #2
                ldy #3*8
arbt_acccommon: jsr accactorx
                lda actcnt,x                    ;Firing?
                beq arbt_nofire2
                dec actcnt,x
                ldy #$10
                lda #WPN_LASER
                jsr enemyshoot
arbt_nofire2:   jsr additiveanim
                and #$01
                sta actf,x
                jsr faceplayer
                cmp actd,x
                bne arst_reverse
                lda actcnt,x
                bne arbt_nofire
                jsr random
                and #$3f
                cmp #$3c
                bcc arbt_nofire
                jsr getplrdistx
                cmp #$80
                bcs arbt_nofire
                jsr getplrdisty
                cmp #$18
                bcs arbt_nofire
                lda #$0a                        ;Fire for 10 frames
                sta actcnt,x
arbt_nofire:    jmp enemyxmotion

ar_fireball:    lda #$03                        ;Check collision with player
                jsr enemycollide
                lda actbits,x                   ;Speed initialized?
                bne arfi_initted
                jsr random
                and #$03
                clc
                adc #-8*8
                sta actsy,x
                jsr random
                and #$07
                tay
                lda arro_xtbl,y
                sta actsx,x
                lda #AB_JUMP
                sta actbits,x
                lda #FX_EXPLOSION
                jsr playfx
arfi_initted:   lda #2
                ldy #8*8
                jsr accactory
                lda #$02
                jsr animdelay
                bcc arfi_noanim
                lda #$01
                jsr fourframeanim
arfi_noanim:    jsr moveactory
                jsr moveactorx
                rts


ar_laser:       lda #$00
                sta actd,x
                lda actxl,x
                lsr
                lsr
                lsr
                lsr
                lsr
                ora actxh,x
                and #$03
                clc
                adc #$03
                jsr animdelay
                bcc ar_lasernoanim
                lda actf,x
                adc #$00
                and #$07
                sta actf,x
ar_lasernoanim: jsr getplrdistx
                cmp #80
                bcs ar_lasernoshoot
                ldy actf,x
                lda ar_lasershottbl,y
                ldy #$00
                jmp enemyshoot
ar_lasernoshoot:rts
ar_lasershottbl:dc.b 15,16,17,18,18,17,16,15


ar_flamer:      lda #$00
                sta actd,x
                jsr getplrdistx
                cmp #64
                bcs ar_noflamer
                jsr faceplayer
                beq ar_noflamer
                lda #19
                ldy #$00
                jsr enemyshoot
                bcc ar_nolongdly
                lda #$01
                sta actcnt,x
                rts
ar_noflamer:    lda actcnt,x        ;After stopping firing there's a long
                beq ar_nolongdly    ;delay before firing again
                lda #$00
                sta actcnt,x
                lda #60
                sta actsd,x
ar_nolongdly:   rts



ar_boss1:       lda acthp,x
                bne arb1_notdead
                lda bossdeath
                bne arb1_dying
                lda #$03
                sta newexplosion
                lda actxl,x
                sec
                sbc #$10
                sta explbasexl
                lda actxh,x
                sbc #$00
                sta explbasexh
                lda actyl,x
                sec
                sbc #$4a
                sta explbaseyl
                lda actyh,x
                sbc #$00
                sta explbaseyh
                lda #$0f
                sta explandx
                lda #$3f
                sta explandy
                lda #200
                sta bossdeath
arb1_dying:     jmp bossdeathrout
arb1_notdead:   lda #$03
                jsr enemycollide
                lda actsd,x
                bne arb1_noattack
                jsr random
                and #$7f
                cmp #$78
                bcc arb1_noattack
                beq arb1_grenade
                ldy #AN_FIRSTENEMY              ;Spawn laser shot if possible
                lda #AN_LASTENEMY+1
                jsr getfreeactor
                bcc arb1_noattack
                jsr arb1_copycoords
                lda #$08
                sta actsd,x
                lda #ACT_SIDELASER              ;Set type & frame & hitpoints
                sta actt,y
                lda #FX_LASER
                jsr playfx
                lda #$00
                sta actf,y
                sta actsy,y
                sty tempval1
                jsr faceplayer
                tay
                lda arb1_xtbl2,y                ;Get speed for laser bullet
                ldy tempval1
                sta actsx,y
                jmp arb1_noattack
arb1_grenade:   ldy #AN_FIRSTENEMY
                lda #AN_LASTENEMY+1
                jsr getfreeactor
                bcc arb1_noattack
                jsr arb1_copycoords
                lda #ACT_BOSSGRENADE
                sta actt,y
                lda #FX_THROW
                jsr playfx
                lda #$00
                sta actf,y
                lda #-6*8
                sta actsy,y
                sty tempval1
                jsr faceplayer
                tay
                lda arrt_xtbl,y
                ldy tempval1
                sta actsx,y
arb1_noattack:  lda #$00
                sta actsx,x
                lda #$05
                jsr animdelay
                bcc arb1_nomove
                jsr fourframeanim2
                ldy actd,x
                lda arb1_xtbl,y
                sta actsx,x
                jmp enemyxmotion
arb1_nomove:    rts
arb1_copycoords:lda actxl,x                     ;Copy coordinates
                sta actxl,y                     ;for boss bullet
                lda actxh,x
                sta actxh,y
                lda actyl,x
                sec
                sbc #52
                sta actyl,y
                lda actyh,x
                sbc #$00
                sta actyh,y
                rts
arb1_xtbl:      dc.b 8*8,-8*8
arb1_xtbl2:     dc.b 15*8,-15*8

ar_boss2:       lda acthp,x
                bne arb2_notdead
                lda bossdeath
                bne arb2_dying
boss2death:     lda #$03
                sta newexplosion
                lda actxl,x
                sec
                sbc #44
                sta explbasexl
                lda actxh,x
                sbc #$00
                sta explbasexh
                lda actyl,x
                sec
                sbc #42
                sta explbaseyl
                lda actyh,x
                sbc #$00
                sta explbaseyh
                lda #$3f
                sta explandx
                sta explandy
                lda #200
                sta bossdeath
arb2_dying:     jmp bossdeathrout
arb2_notdead:   lda #$03
                jsr enemycollide
                lda actsd,x
                bne arb2_noattack
                jsr random
                and #$3f
                cmp #$34
                bcc arb2_noattack
arb2_launchlaser:
                ldy #AN_FIRSTENEMY
                lda #AN_LASTENEMY
                jsr getfreeactor
                bcc arb2_noattack
                jsr copycoords
                lda #$06
                sta actsd,x
                lda actyl,y
                clc
                adc #$12
                sta actyl,y
                lda actyh,y
                adc #$00
                sta actyh,y
                inc actcnt,x
                lda actcnt,x
                and #$01
                stx tempval1
                tax
                lda actxl,y
                clc
                adc arb2_modtbllo,x
                sta actxl,y
                lda actxh,y
                adc arb2_modtblhi,x
                sta actxh,y
                ldx tempval1
                lda #ACT_VERTICALLASER
                sta actt,y
                lda #FX_LASER
                jsr playfx
                lda #$00
                sta actf,y
                sta actsx,y
                lda #15*8
                sta actsy,y
arb2_noattack:  jsr getcharpos
                lda actd,x
                beq arb2_checkright
arb2_checkleft: dec charmapx
                dec charmapx
                dec charmapx
                jsr getcharinfo
                inc charmapx
                inc charmapx
                inc charmapx
                jmp arb2_docheck
arb2_checkright:inc charmapx
                inc charmapx
                inc charmapx
                jsr getcharinfo
                dec charmapx
                dec charmapx
                dec charmapx
arb2_docheck:   and #CI_OBSTACLE
                beq arb2_noreverse
                jsr reverseactor
arb2_noreverse: lda actd,x
                bne arb2_accleft
                lda #2
                ldy #6*8
                bne arb2_acccommon
arb2_accleft:   lda #-2
                ldy #-6*8
arb2_acccommon: jsr accactorx
                jsr checkobst2
                jsr moveactorx
                rts
arb2_modtbllo:  dc.b 22,-24
arb2_modtblhi:  dc.b 0,$ff

ar_boss3:       lda acthp,x
                bne arb3_notdead
                lda bossdeath
                bne arb3_dying
                ldy #AN_FIRSTENEMY
arb3_killslimes:lda actt,y
                cmp #ACT_SLIME
                bne arb3_killslimeskip
                lda #$00
                sta acthp,y
arb3_killslimeskip:
                iny
                cpy #AN_LASTENEMY+1
                bcc arb3_killslimes
                jmp boss2death
arb3_dying:     jmp bossdeathrout
arb3_notdead:   lda #$03
                jsr enemycollide
                jsr random
                and #$1f
                bne arb3_nospawn
                ldy #AN_FIRSTENEMY
                lda #AN_LASTENEMY+1
                jsr getfreeactor
                bcc arb3_nospawn
                jsr copycoords
                lda #ACT_SLIME
                sta actt,y
                lda #10
                sta acthp,y
                lda actyl,y
                sec
                sbc #$15
                sta actyl,y
                lda actyh,y
                sbc #$00
                sta actyh,y
                jsr random
                and #$03
                asl
                asl
                asl                             ;Carry=0
                sbc #64-1
                sta actsy,y
                jsr random
                and #$07                        ;Set delay for next jump
                sta actcnt,y
                jsr random                      ;Set direction for this jump
                and #$01
                sta actd,y
                lda #AB_JUMP
                sta actbits,y
                lda #$04
                sta actf,y
                lda #$02
                sta actf,x
                lda #FX_JUMP
                jsr playfx
arb3_nospawn:   lda actf,x
                cmp #$02
                bcs arb3_spawnanim
                lda #$04
                jsr animdelay
                bcc arb3_noanim
                lda actf,x
                eor #$01
                sta actf,x
arb3_noanim:    rts
arb3_spawnanim: lda #$04
                jsr animdelay
                bcc arb3_noanim
                inc actf,x
                lda actf,x
                cmp #$04
                bcc arb3_noanim
                lda #$00
                sta actf,x
                rts

ar_boss4:       inc bosslight
                lda bosslight
                and #$07
                tay
                lda arb4_color1tbl,y
                sta r1_setbg2+1
                lda arb4_color2tbl,y
                sta r1_setbg3+1
                lda acthp,x
                bne arb4_notdead
                lda bossdeath
                bne arb4_dying
                ldy #AN_FIRSTENEMY
arb4_killdroids:lda actt,y
                cmp #ACT_SLIME
                bne arb4_killdroidskip
                lda #$00
                sta acthp,y
arb4_killdroidskip:
                iny
                cpy #AN_LASTENEMY+1
                bcc arb4_killdroids

boss4death:     lda #$03
                sta newexplosion
                lda actxl,x
                sec
                sbc #44
                sta explbasexl
                lda actxh,x
                sbc #$00
                sta explbasexh
                lda actyl,x
                sec
                sbc #42
                sta explbaseyl
                lda actyh,x
                sbc #$00
                sta explbaseyh
                lda #$3f
                sta explandx
                sta explandy
                lda #200
                sta bossdeath
arb4_dying:     jmp bossdeathrout
arb4_notdead:   jsr random
                cmp #$fc                ;Spawn a droid?
                bcc arb4_nospawn

                ldy #AN_FIRSTENEMY
                lda #AN_LASTENEMY+1
                jsr getfreeactor
                bcc arb4_nospawn
                lda #$03
                sta actf,x
                jsr copycoords
                lda #ACT_DROID
                sta actt,y
                lda #6
                sta acthp,y
                lda #$00
                sta actsx,y
                sta actsy,y
                sta actf,y
                sta actfd,y
                sta actcnt,y
                sta actbits,y
                lda #FX_PUNCH
                jsr playfx

arb4_nospawn:   lda actf,x                      ;Mouth open?
                beq arb4_noanim
                lda #$02
                jsr animdelay
                bcc arb4_noanim
                dec actf,x
arb4_noanim:    ldy actd,x
                lda arb4_speedtbl,y
                sta actsx,x
                ldy actcnt,x
                lda arb4_speedtbl,y
                sta actsy,x
                jsr getcharpos
                jsr checkobsty
                bcs arb4_yreverse
                jsr moveactory
arb4_movex:     jsr checkobst2
                bcs arb4_reverse
                jmp moveactorx
arb4_reverse:   jmp reverseactor
arb4_yreverse:  lda actcnt,x
                eor #$01
                sta actcnt,x
                jmp arb4_movex
arb4_speedtbl:  dc.b 2*8, -2*8
arb4_color1tbl: dc.b 11,2,11,9,0,0,0,0
arb4_color2tbl: dc.b 4,8,4,2,9,9,9,9


ar_sidelaser:   lda #$08
                jsr enemycollide
                bcc arsla_nocoll
arsla_remove:   lda #ACT_EMPTY
                sta actt,x
                rts
arsla_nocoll:   jsr moveactorx
                jsr moveactory
                jsr getcharpos
                jsr getcharinfo
                and #CI_OBSTACLE
                bne arsla_remove
                rts

ar_bossgrenade: ldy #$00
                jsr actorcollide
                bcc argr_nocoll
argr_explode:   jmp armn_explode
argr_nocoll:    lda #4
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr moveactorx
                jsr getcharpos
                jsr getcharinfo
                and #CI_OBSTACLE
                bne argr_explode
                rts

bossdeathrout:  lda #$02
                sta srchi
                lda #$50
                sta srclo
                jsr addscore
                lda bossdeath
                sta actfls,x
                and #$07
                bne bdr_noexpl
                lda #$01
                jsr addexp
bdr_noexpl:     dec bossdeath
                bne bdr_notready
                stx bdr_restx+1
                lda actt,x
                sec
                sbc #ACT_BOSS1
                asl
                tax
                lda bosseffecttbl,x
                sta bdr_effectjump+1
                lda bosseffecttbl+1,x
                sta bdr_effectjump+2
                lda level                       ;Death of boss may
                jsr putleveldata                ;effect some changes
bdr_effectjump: jsr $0000                       ;in leveldata
                lda level
                jsr getleveldata
                jsr addallactors
bdr_restx:      ldx #$00
                lda #$00
                sta actt,x
                sta bossfight
                sta newexplosion
bdr_notready:   rts
bosseffecttbl:  dc.w initdisk1
                dc.w initdisk3
                dc.w initdisk2
                dc.w completegame

completegame:   lda #$01
                sta gamecomplete
                rts

fourframeanim:  jsr animdelay
                bcc ffa_done
fourframeanim2: lda actf,x
                adc #$00
                and #$03
                sta actf,x
ffa_done:       rts

        ;A=dead actor type
enemydeath_fly: pha
                jsr enemyreward
                pla
                sta actt,x
                lda #FX_DEATH
                jsr playfx
                lda #$01
                sta actf,x
                lda #-5*8
                sta actsy,x
                jsr random
                and #$03
                tay
                lda edf_xspdtbl,y
                sta actsx,x
                lda #$00
                sta actcnt,x
                lda actyl,x
                sec
                sbc #$10
                sta actyl,x
                bcs edf_nohigh
                dec actyh,x
edf_nohigh:     rts
edf_xspdtbl:    dc.b 2*8,1*8,-1*8,-2*8

        ;A=dead actor type
enemydeath_expl:pha
                jsr enemyreward
                pla
enemyexpl_noscore:sta actt,x
                lda #FX_EXPLOSION
                jsr playfx
                lda #$00
                sta actf,x
                sta actfd,x
                sta acthp,x
                rts

ar_corpse:      lda actf,x
                beq arco_rot
                lda #4
                ldy #8*8
                jsr accactory
                jsr moveactory
                jsr getcharpos
                jsr landingcheck
                bcs arco_jumpdone
                jsr checkobst2                  ;In jumps obstacles should
                jsr moveactorx                  ;be checked one char lower
                jsr getcharpos
                jsr landingcheck
arco_jumpdone:  rts
arco_rot:       inc actcnt,x
                lda actcnt,x
                cmp #ENEMYDEADTIME
                bcc arco_jumpdone
                lda #$00
                sta actt,x
                rts

ar_shopkeeper:  lda actt,x
                sec
                sbc #ACT_GUNSHOP
ar_shopcommon:  sta actf,x
ar_actor:       inc actorpresent
                rts

ar_shopkeeper2: lda actt,x
                sec
                sbc #ACT_ULTRASHRED
                jmp ar_shopcommon

ar_band:        inc actorpresent
                lda #$02
                jmp fourframeanim

ar_ai:          lda #$03
                jsr fourframeanim
                jmp ar_actor


transformai:    ldy #AN_FIRSTENEMY
transailoop:    lda actt,y
                cmp #ACT_AI
                bne transaiskip
                lda #ACT_BOSS4
                sta actt,y
                lda #$01
                sta bossfight
                lda #$00
                sta bossdeath
                sta actf,y
                lda #BOSS4HEALTH
                sta acthp,y
                lda #$01
                sta actd,y
                sta actcnt,y
                rts
transaiskip:    iny
                cpy #AN_LASTENEMY+1
                bcc transailoop
                rts



initexplosion:  lda #$00
                sta explosioncount
                sta newexplosion
                ldx #MAXEXPL-1
                lda #$ff
initexplloop:   sta explf,x
                dex
                bpl initexplloop
                rts

updexplosion:   lda explosioncount
                clc
                adc newexplosion
                cmp #$08
                bcs createexplosion
                sta explosioncount
                jmp updexplosion2
createexplosion:sbc #$08
                sta explosioncount
                ldx #MAXEXPL-1
searchexpl:     lda explf,x
                bmi sexpfound
                dex
                bpl searchexpl
                jmp updexplosion2
sexpfound:      lda #$00
                sta explf,x
                jsr random
                and explandx
                clc
                adc explbasexl
                sta explxl,x
                lda explbasexh
                adc #$00
                sta explxh,x
                jsr random
                and explandy
                clc
                adc explbaseyl
                sta explyl,x
                lda explbaseyh
                adc #$00
                sta explyh,x
                lda #FX_EXPLOSION
                jsr playfx
updexplosion2:  ldx #MAXEXPL-1
updexplloop:    lda explf,x
                bmi updexplnext
                clc
                adc #$01
                cmp #5*2
                bcc updexplnotover
                lda #$ff
updexplnotover: sta explf,x
updexplnext:    dex
                bpl updexplloop
                rts

drawexplosion:  ldx #MAXEXPL-1
drawexplloop:   lda explf,x
                bmi drawexplnext
                ldy numspr
                cpy #MAXSPR
                bcs drawexpldone
                lda explxl,x
                sec
                sbc scrollsubxl
                sta sprxl,y
                lda explxh,x
                sbc scrollsubxh
                sta sprxh,y
                lda explyl,x
                sec
                sbc scrollsubyl
                sta spryl,y
                lda explyh,x
                sbc scrollsubyh
                sta spryh,y
                lda #$00
                sta sprfls,y
                lda explf,x
                lsr
                clc
                adc #122
                sta sprf,y
                inc numspr
drawexplnext:   dex
                bpl drawexplloop
drawexpldone:   rts

enemyreward:    lda actt,x
                sec
                sbc #ACT_FISTMAN
                asl
                asl
                tay
                lda actrewardtbl,y
                sta srclo
                lda actrewardtbl+1,y
                sta srchi
                jsr addscore
                lda explevel                    ;For purpose of counting
                cmp #$04                        ;experience-subtract, level
                bcc enrw_nothighlevel           ;is never higher than 4
                lda #$03
enrw_nothighlevel:sta enrw_sub+1
                sed
                lda actrewardtbl+2,y            ;If player is on higher level,
                sec                             ;give less experience
enrw_sub:       sbc #$00
                bcc enrw_skip                   ;If it goes negative, skip
                jmp addexp
enrw_skip:      cld
                rts

copycoords:     lda actxl,x                     ;Copy coordinates
                sta actxl,y
                lda actxh,x
                sta actxh,y
                lda actyl,x
                sta actyl,y
                lda actyh,x
                sta actyh,y
                rts

        ;Additive animation for enemies who use multiple speeds and/or
        ;walk backwards
        ;Returns frame in A

additiveanim:   lda actsx,x
                clc
                adc actfd,x
                sta actfd,x
                lsr
                lsr
                lsr
                lsr
                lsr
                rts

        ;A=amount of damage if collision happens
        ;C=1 if collision happens!

enemycollide:   sta enco_damage+1
                lda actfls                      ;Player immortal?
                bne enco_not
                ldy #$00                        ;Check collision with player
                jsr actorcollide
                bcc enco_not
                jsr faceplayer
                tay
                lda dpd_facetable,y
                sta dpd_xspeed+1
enco_damage:    lda #$00
                jsr doplrdamage
                sec
                rts
enco_not:       clc
                rts

powerup:        lda bossfight
                ora bossdeath
                bne powerup_no
                lda actt,x
                sec
                sbc #ACT_FISTMAN
                asl
                asl
                tay
                lda actrewardtbl+3,y
                sta poweruptbl+7
                sta poweruptbl+15
                jsr random
                and #$0f
                tay
                lda poweruptbl,y
                beq powerup_no
                sta powerup_num+1
                ldy #AN_FIRSTITEM
                lda #AN_LASTITEM+1
                jsr getfreeactor
                bcc powerup_no
                lda #ACT_ITEM
                sta actt,y
powerup_num:    lda #$00
                sta actf,y
                lda actxl,x
                sta actxl,y
                lda actxh,x
                sta actxh,y
                lda actyl,x
                sta actyl,y
                lda actyh,x
                sta actyh,y
                lda #-7*8
                sta actsy,y
                lda #AB_JUMP
                sta actbits,y
powerup_no:     rts

bossmusic:      lda bossfight
                cmp prevbossfight
                beq bmus_nochange
                lda bossfight
                sta prevbossfight
                beq bmus_leveltune
                lda #MUSIC_BOSSFIGHT
                jsr playtune
bmus_nochange:  rts
bmus_leveltune: jmp playleveltune
