;ͻ
;Metal Warrior 2 - Loader routines                                            
;Started in 8/1999!                                                           
;ͼ

;Ŀ
;SAVEHISCORE                                                                  
;                                                                             
;Uninitializes fastloader and saves the hiscore/configuration file.           
;Fastloader will be re-initted next time when it is needed.                   
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

savehiscore:    jsr fadetune
                jsr blankgamescreen
                jsr waitraster0
                jmp loader_savehisc

;Ŀ
;LOAD                                                                         
;                                                                             
;The high level load routine, which calls the low-level loader and in the     
;case of error, lets user retry by pressing fire.                             
;                                                                             
;Parameters: X,Y: 2 first letters of filename                                 
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

load:           stx load_again+1                ;Store name
                sty load_sety+1
                jsr fadetune
                jsr blankgamescreen
                jsr waitraster0
                jsr initmsg
load_again:     ldx #$00
load_sety:      ldy #$00
                jsr loader_loadfile
                bcs load_error
load_ok:        jmp initmap                     ;Loader tables & map tables
load_error:     lda #27                         ;overlap
                sta msgnum
                jsr msgroutine
load_wait:      jsr waitraster0
                jsr getcontrols
                jsr getfireclick
                bcc load_wait
                jmp load_again
