;ͻ
;COVERT BITOPS fastloader/leveldepacker/configuration                         
;ͼ

                include zeropage.s
                include define.s

status          = $90           ;Kernal zeropage variables
fa              = $ba
ciout           = $ffa8         ;Kernal routines
listen          = $ffb1
second          = $ff93
unlsn           = $ffae
acptr           = $ffa5
chkin           = $ffc6
chkout          = $ffc9
chrin           = $ffcf
chrout          = $ffd2
ciout           = $ffa8
close           = $ffc3
open            = $ffc0
setmsg          = $ff90
setnam          = $ffbd
setlfs          = $ffba
clrchn          = $ffcc
getin           = $ffe4


ASCII_F1        = $85           ;Function key ASCII codes
ASCII_F3        = $86
ASCII_F5        = $87
ASCII_F7        = $88

cfgtemp1        = $02           ;Temp variable for the configuration screen

                processor 6502

;Ŀ
;This is the configuration menu code, which will be overwritten by sprite     
;tables etc. when the main part starts.                                       
;

                org $400

configtext:     dc.b "     M"
                dc.b "e"-96
                dc.b "t"-96
                dc.b "a"-96
                dc.b "l"-96
                dc.b " W"
                dc.b "a"-96
                dc.b "r"-96
                dc.b "r"-96
                dc.b "i"-96
                dc.b "o"-96
                dc.b "r"-96
                dc.b " 2 C"
                dc.b "o"-96
                dc.b "n"-96
                dc.b "f"-96
                dc.b "i"-96
                dc.b "g"-96
                dc.b "u"-96
                dc.b "r"-96
                dc.b "a"-96
                dc.b "t"-96
                dc.b "i"-96
                dc.b "o"-96
                dc.b "n"-96
                dc.b "      "
                dc.b "                                        "
                dc.b "     F1 - F"
                dc.b "a"-96
                dc.b "s"-96
                dc.b "t"-96
                dc.b "l"-96
                dc.b "o"-96
                dc.b "a"-96
                dc.b "d"-96
                dc.b "e"-96
                dc.b "r"-96
                dc.b "                    "

                dc.b "     F3 - L"
                dc.b "o"-96
                dc.b "a"-96
                dc.b "d"-96
                dc.b "i"-96
                dc.b "n"-96
                dc.b "g"-96
                dc.b " "
                dc.b "p"-96
                dc.b "i"-96
                dc.b "c"-96
                dc.b "t"-96
                dc.b "u"-96
                dc.b "r"-96
                dc.b "e"-96
                dc.b "               "
                dc.b "     F5 - R"
                dc.b "e"-96
                dc.b "s"-96
                dc.b "e"-96
                dc.b "t"-96
                dc.b " "
                dc.b "h"-96
                dc.b "i"-96
                dc.b "s"-96
                dc.b "c"-96
                dc.b "o"-96
                dc.b "r"-96
                dc.b "e"-96
                dc.b "s"-96
                dc.b "                "
                dc.b "     F7 - C"
                dc.b "o"-96
                dc.b "n"-96
                dc.b "t"-96
                dc.b "i"-96
                dc.b "n"-96
                dc.b "u"-96
                dc.b "e"-96
                dc.b " "
                dc.b "l"-96
                dc.b "o"-96
                dc.b "a"-96
                dc.b "d"-96
                dc.b "i"-96
                dc.b "n"-96
                dc.b "g"-96
                dc.b "              "
                dc.b "                                        "
                dc.b "       A"
                dc.b "u"-96
                dc.b "t"-96
                dc.b "o"-96
                dc.b "s"-96
                dc.b "t"-96
                dc.b "a"-96
                dc.b "r"-96
                dc.b "t"-96
                dc.b "i"-96
                dc.b "n"-96
                dc.b "g"-96
                dc.b " "
                dc.b "i"-96
                dc.b "n"-96
                dc.b "   "
                dc.b "s"-96
                dc.b "e"-96
                dc.b "c"-96
                dc.b "o"-96
                dc.b "n"-96
                dc.b "d"-96
                dc.b "s"-96
                dc.b "        "






                org $620

startconfig:    lda #$36
                sta $01
                lda $d011
                and #$ef
                sta $d011
                jsr clearhiscores
                jsr initloader
                lda #$00
                sta $d020
                sta $d021
                jsr configscreen
                lda showloadpic
                beq loadmainpart
                ldx #"P"                        ;P0 = loading picture
                ldy #"0"
                jsr loadfile_exomizer
                jsr $c000
loadmainpart:   ldx #"P"                        ;P1 = main part
                ldy #"1"
                jsr loadfile_exomizer
                jmp maincodestart               ;Start main program

configscreen:   jsr clrchn
                ldx #$00
                ldy #$04
fillscreen:     lda #$20
fillscreen_sta1:sta $2000,x
                lda #$0f
fillscreen_sta2:sta $d800,x
                inx
                bne fillscreen
                inc fillscreen_sta1+2
                inc fillscreen_sta2+2
                dey
                bne fillscreen
copytext:       lda configtext,x
                sta $2000+7*40,x
                lda configtext+160,x
                sta $2000+7*40+160,x
                inx
                cpx #160
                bne copytext
                lda #27
                sta $d011
                lda #8
                sta $d016
                lda #$86
                sta $d018
configloop:     jsr printonoff
waitkey:        lda $d012
                cmp #$f8
                bcc waitkey
waitkey2:       lda $d012
                cmp #$f8
                bcs waitkey2
                lda seconds
                bmi nocountdown
                dec timedelay
                bpl nocountdown
                lda #50
                sta timedelay
                dec seconds
                beq continueload_nosave
                lda seconds
                ora #$30
                sta $2000+14*40+23
nocountdown:    jsr getin
                beq waitkey
                pha
                lda #$ff
                sta seconds
                ldx #39
                lda #$20
hidecountdown:  sta $2000+14*40,x
                dex
                bpl hidecountdown
                pla
                ldx #$00
                cmp #ASCII_F1
                beq togglevalue
                cmp #"1"
                beq togglevalue
                inx
                cmp #ASCII_F3
                beq togglevalue
                cmp #"2"
                beq togglevalue
                cmp #ASCII_F5
                bne nohiscore
                cmp #"3"
                bne nohiscore
                lda #$01
                sta configmodified
                jsr clearhiscores
nohiscore:      cmp #ASCII_F7
                beq continueload
                cmp #13
                bne configloop
continueload:   lda configmodified
                beq continueload_nosave
                jsr savehiscores
continueload_nosave:
                lda #$03
                sta $d011
                rts

togglevalue:    lda #$01
                sta configmodified
                lda usefastload,x
                eor #$01
                sta usefastload,x
                jmp configloop

clearhiscores:  ldx #$03
chscloop:       ldy #$0a
                lda #"."
                jsr chscsub
                tya
                inx
                inx
                inx
                inx
                cpx #143
                bne chscloop
                lda #$00
                ldx #140
                ldy #40
                jmp chscsub
chscsub:        sta hiscores,x
                inx
                dey
                bne chscsub
                rts

printonoff:     ldx #31
                lda usefastload
                jsr printonoff2
                ldx #71
                lda showloadpic
printonoff2:    lsr
                ldy #$03
                sty cfgtemp1
                bcs printonoff3
                tay
printonoff3:    lda onofftext,y
                sta $2000+9*40,x
                iny
                inx
                dec cfgtemp1
                bne printonoff3
                rts

configmodified: dc.b 0
timedelay:      dc.b 0
seconds:        dc.b 6
onofftext:      dc.b "O"
                dc.b "f"-96
                dc.b "f"-96
                dc.b " "
                dc.b "O"
                dc.b "n"-96

                org $0800

                org $0800

;-------------------------------------------------------------------------------
; COVERT BITOPS loader/depacker
; with 1541/1571/1581/CMD FD/CMD HD/IDE64 support
;
; EXOMIZER compressor by Magnus Lind
; 1581/CMD FD/CMD HD information from Ninja & DocBacardi /The Dreams
; 2bit 2MHz transfer by Magervalp
; Rest by Lasse rni
;
; Thanks to K.M/TABOO for inspiration on badline detection and 1-bit transfer,
; Marko Mkel for his original irqloader.s (huge inspiration) & MuOn for
; testing the 2-bit transfer on a NTSC C64.
;-------------------------------------------------------------------------------

                processor 6502

;-------------------------------------------------------------------------------
; Include your loader configuration file at this point!
;-------------------------------------------------------------------------------

LONG_NAMES      = 0             ;Set to nonzero to use long names (pointer in
                                ;X,Y) or zero to use 2-letter names (letters
                                ;in X,Y)
BORDER_FLASHING = 0             ;Set to nonzero to enable border flashing
                                ;when fastloading :)
ADDITIONAL_ZEROPAGE = 0         ;Set to nonzero to use additional zeropage
                                ;variables to shorten loader code
HISCORE_SUPPORT = 1             ;Set to nonzero to include hiscore load/save

HISCORESIZE     = 180           ;Size of hiscores in bytes
HINAMELENGTH    = 2             ;Length of hiscore filename

RETRIES         = 5             ;Retries when reading a sector

loadbuffer      = $0400         ;256 byte table used by fastloader & REU

depackbuffer    = $0500         ;156 bytes for EXOMIZER tables, 31 for
                                ;PUCRUNCH.

zpbase          = $78           ;Zeropage base address. Loader needs 2
                                ;addresses with unpacked, 3 with PUCRUNCH
                                ;and 8 with EXOMIZER loading.


;-------------------------------------------------------------------------------
; Defines derived from the compile options (need not be changed)
;-------------------------------------------------------------------------------

CONFIGSIZE      = 2 ;Configuration size in bytes

                if ADDITIONAL_ZEROPAGE>0
loadtempreg     = zpbase2+0      ;Temp variables for the loader
bufferstatus    = zpbase2+1      ;Bytes in fastload buffer
fileopen        = zpbase2+2      ;File open indicator
fastloadstatus  = zpbase2+3      ;Fastloader active indicator
                endif

;-------------------------------------------------------------------------------
; Other defines
;-------------------------------------------------------------------------------

status          = $90           ;Kernal zeropage variables
messages        = $9d
fa              = $ba

ciout           = $ffa8         ;Kernal routines
listen          = $ffb1
second          = $ff93
unlsn           = $ffae
acptr           = $ffa5
chkin           = $ffc6
chkout          = $ffc9
chrin           = $ffcf
chrout          = $ffd2
close           = $ffc3
open            = $ffc0
setmsg          = $ff90
setnam          = $ffbd
setlfs          = $ffba
clrchn          = $ffcc
getin           = $ffe4
load            = $ffd5
save            = $ffd8

fastloadstatus: dc.b 0          ;Fastloader active indicator
loadtempreg:    dc.b 0          ;Temp variable for the loader
bufferstatus:   dc.b 0          ;Bytes in fastload buffer
fileopen:       dc.b 0          ;File open indicator

;-------------------------------------------------------------------------------
; Resident portion of loader (routines that you're going to use at runtime)
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
; LOADFILE_EXOMIZER
;
; Loads a file packed with EXOMIZER
;
; Parameters: X (low),Y (high): Address of null-terminated filename
; Returns: C=0 OK, C=1 error (A holds errorcode)
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

tabl_bi         = depackbuffer
tabl_lo         = depackbuffer+52
tabl_hi         = depackbuffer+104

zp_len_lo       = zpbase+0
zp_src_lo       = zpbase+1
zp_src_hi       = zpbase+2
zp_bits_lo      = zpbase+3
zp_bits_hi      = zpbase+4
zp_bitbuf       = zpbase+5
zp_dest_lo      = zpbase+6
zp_dest_hi      = zpbase+7

loadfile_exomizer:
                jsr openfile
                tsx
                stx exomizer_stackptr+1
                jsr exomizer_depack
                clc
                rts

; -------------------------------------------------------------------
; EXOMIZER depackroutine by Magnus Lind
; Modified by Lasse rni for interrupt disabling (loading under I/O)
; and to call getbyte directly without need for a "wrapper" routine
; that slows down decrunching/loading
; -------------------------------------------------------------------
;
; Copyright (c) 2002 Magnus Lind.
;
; This software is provided 'as-is', without any express or implied warranty.
; In no event will the authors be held liable for any damages arising from
; the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
;   1. The origin of this software must not be misrepresented; you must not
;   claim that you wrote the original software. If you use this software in a
;   product, an acknowledgment in the product documentation would be
;   appreciated but is not required.
;
;   2. Altered source versions must be plainly marked as such, and must not
;   be misrepresented as being the original software.
;
;   3. This notice may not be removed or altered from any distribution.
;
;   4. The names of this software and/or it's copyright holders may not be
;   used to endorse or promote products derived from this software without
;   specific prior written permission.
;
; exodecruncher.s, a part of the exomizer v1.0 release
; -------------------------------------------------------------------
; no code below this comment has to be modified in order to generate
; a working decruncher of this source file.
; However, you may want to relocate the tables last in the file to a
; more suitable adress.
; -------------------------------------------------------------------

; -------------------------------------------------------------------
; jsr this label to decrunch, it will in turn init the tables and
; call the decruncher
; no constraints on register content, however the
; decimal flag has to be #0 (it almost always is, otherwise do a cld)
exomizer_depack:
; -------------------------------------------------------------------
; init zeropage (12 bytes)
;
	ldy #0
	ldx #3
init_zp:
        php
	jsr getbyte
        bcs exomizer_fail
        plp
	sta zp_bitbuf - 1,x
	dex
	bne init_zp
; -------------------------------------------------------------------
; calculate tables (53 bytes)
; x and y must be #0 when entering
;
nextone:
	inx
	tya
	and #$0f
	beq shortcut		; starta p ny sekvens

	lda zp_bits_lo
	adc tabl_lo-1,y
	tax

	lda zp_bits_hi
	adc tabl_hi-1,y
shortcut:
	sta tabl_hi,y
	txa
	sta tabl_lo,y

	ldx #4
	jsr get_bits		; clears x-reg.
	sta tabl_bi,y

	stx zp_bits_lo		; zp_bits_hi is already 0 because
	tax			; we called get_bits with x = 4
	inx
	sec
rolle:
	rol zp_bits_lo
	rol zp_bits_hi
	dex
	bne rolle		; c = 0 after this
skip:
	iny
	cpy #52
	bne nextone
	ldy #0
	beq begin
; -------------------------------------------------------------------
; get x + 1 bits (1 byte)
;
get_bit1:
	inx
; -------------------------------------------------------------------
; get bits (31 bytes)
;
; args:
;   x = number of bits to get
; returns:
;   a = #bits_lo
;   x = #0
;   c = 0
;   zp_bits_lo = #bits_lo
;   zp_bits_hi = #bits_hi
; notes:
;   y is untouched
;   other status bits are set to (a == #0)
; -------------------------------------------------------------------
get_bits:
	lda #$00
	sta zp_bits_lo
	sta zp_bits_hi
	cpx #$01
	bcc bits_done
	lda zp_bitbuf
bits_next:
	lsr
	bne bits_ok
        php
	jsr getbyte
        bcs exomizer_fail
        plp
	ror
bits_ok:
	rol zp_bits_lo
	rol zp_bits_hi
	dex
	bne bits_next
	sta zp_bitbuf
	lda zp_bits_lo
bits_done:
	rts
; -------------------------------------------------------------------
; Failure when reading a byte: restore stackptr and exit
;
exomizer_fail:                          ;A premature EOF is treated as an
exomizer_stackptr:                      ;error; return directly to caller
        ldx #$00
        txs
        rts
; -------------------------------------------------------------------
; main copy loop (16 bytes)
;
copy_next_hi:
	dex
	dec zp_dest_hi
	dec zp_src_hi
copy_next:
	dey
    lda $01
    sta enableio_01+1
    sei
    lda #$34
    sta $01
	lda (zp_src_lo),y
literal_entry:
	sta (zp_dest_lo),y
enableio_01:
    lda #$36
    sta $01
    cli
copy_start:
	tya
	bne copy_next
	txa
	bne copy_next_hi
; -------------------------------------------------------------------
; decruncher entry point, needs calculated tables (5 bytes)
; x and y must be #0 when entering
;
begin:
	jsr get_bit1
	beq sequence
; -------------------------------------------------------------------
; literal handling (13 bytes)
;
literal_start:
	lda zp_dest_lo
	bne avoid_hi
	dec zp_dest_hi
avoid_hi:
	dec zp_dest_lo
        php
        jsr getbyte
        bcs exomizer_fail
        plp
        bcs sequence
    pha
    lda $01
    sta enableio_01+1
    sei
    lda #$34
    sta $01
    pla
	bcc literal_entry
; -------------------------------------------------------------------
; count zero bits + 1 to get length table index (10 bytes)
; y = x = 0 when entering
;
sequence:
next1:
	iny
	jsr get_bit1
	beq next1
	cpy #$11
	bcs bits_done
; -------------------------------------------------------------------
; calulate length of sequence (zp_len) (17 bytes)
;
	ldx tabl_bi - 1,y
	jsr get_bits
	adc tabl_lo - 1,y
	sta zp_len_lo
	lda zp_bits_hi
	adc tabl_hi - 1,y
	pha
; -------------------------------------------------------------------
; here we decide what offset table to use (20 bytes)
; x is 0 here
;
	bne nots123
	ldy zp_len_lo
	cpy #$04
	bcc size123
nots123:
	ldy #$03
size123:
	ldx tabl_bit - 1,y
	jsr get_bits
	adc tabl_off - 1,y
	tay
; -------------------------------------------------------------------
; prepare zp_dest (11 bytes)
;
	sec
	lda zp_dest_lo
	sbc zp_len_lo
	sta zp_dest_lo
	bcs noborrow
	dec zp_dest_hi
noborrow:
; -------------------------------------------------------------------
; calulate absolute offset (zp_src) (27 bytes)
;
	ldx tabl_bi,y
	jsr get_bits;
	adc tabl_lo,y
	bcc skipcarry
	inc zp_bits_hi
	clc
skipcarry:
	adc zp_dest_lo
	sta zp_src_lo
	lda zp_bits_hi
	adc tabl_hi,y
	adc zp_dest_hi
	sta zp_src_hi
; -------------------------------------------------------------------
; prepare for copy loop (6 bytes)
;
	ldy zp_len_lo
	pla
	tax
	jmp copy_start
; -------------------------------------------------------------------
; two small static tables (6 bytes)
;
tabl_bit:
	dc.b 2,4,4
tabl_off:
	dc.b 48,32,16
; -------------------------------------------------------------------
; end of decruncher
; -------------------------------------------------------------------

;-------------------------------------------------------------------------------
; OPENFILE
;
; Opens a file either with slow or fast loader.
; If a file is already open, does nothing!
;
; Parameters: X (low),Y (high): Address of null-terminated filename
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

openfile:       lda fileopen            ;A file already open?
                beq open_ok
                rts
open_ok:        if LONG_NAMES>0
                stx destlo
                sty desthi
                else
                stx filename
                sty filename+1
                endif
                inc fileopen            ;File opened
                jsr initfastload        ;Init fastloader if needed
                lda fastloadstatus
                lsr
                bcs fastopen

;-------------------------------------------------------------------------------
; SLOWOPEN
;
; Opens a file without fastloader.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

slowopen:       lda #$00
                if LONG_NAMES>0
                tay
                endif
                jsr kernalon
                if LONG_NAMES>0
slowopen_nameloop:
                iny
                lda (destlo),y
                bne slowopen_nameloop
                tya
                ldx destlo
                ldy desthi
                else
                lda #$03
                ldx #<filename
                ldy #>filename
                endif
                jsr setnam
                lda #$02
                ldy #$00
                jsr setlfsdevice
                jsr open
                ldx #$02                ;File number
                jmp chkin

;-------------------------------------------------------------------------------
; FASTOPEN
;
; Opens a file with fastloader. Uses an asynchronous protocol inspired by
; Marko Mkel's work when sending the filename.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

fastopen:       if LONG_NAMES>0
                ldy #$00
fastload_sendouter:
                lda (destlo),y
                sta loadtempreg
                pha
                ldx #$08                ;Bit counter
                else
                ldx #$01
fastload_sendouter:
                ldy #$08                ;Bit counter
                endif
fastload_sendinner:
                bit $dd00               ;Wait for both DATA & CLK to go high
                bpl fastload_sendinner
                bvc fastload_sendinner
                if LONG_NAMES=0
                lsr filename,x
                else
                lsr loadtempreg
                endif
                lda #$10
                ora $dd00
                bcc fastload_zerobit
                eor #$30
fastload_zerobit:
                sta $dd00
                lda #$c0                ;Wait for CLK & DATA low (answer from
fastload_sendack:                       ;the diskdrive)
                bit $dd00
                bne fastload_sendack
                lda #$ff-$30            ;Set DATA and CLK high
                and $dd00
                sta $dd00
                if LONG_NAMES>0
                dex
                bne fastload_sendinner
                iny
                pla
                bne fastload_sendouter
                else
                dey
                bne fastload_sendinner
                dex
                bpl fastload_sendouter
                endif
fastload_predelay:
                dex                     ;Delay to make sure the 1541 has
                bne fastload_predelay   ;set DATA high before we continue

fastload_fillbuffer:
                ldx #$00
fastload_fbwait:
                bit $dd00               ;Wait for 1541 to signal data ready by
                bmi fastload_fbwait     ;setting DATA low
fastload_fbloop:
                sei
fastload_waitbadline:
                lda $d011               ;Check that a badline won't disturb
                clc                     ;the timing
                sbc $d012
                and #$07
                beq fastload_waitbadline
                lda $dd00
                ora #$10
                sta $dd00               ;Set CLK low
fastload_delay: bit $00                 ;Delay (NTSC version, will be modified for PAL)
                nop
                and #$03
                sta fastload_eor+1
                sta $dd00               ;Set CLK high
                lda $dd00
                lsr
                lsr
                eor $dd00
                lsr
                lsr
                eor $dd00
                lsr
                lsr
fastload_eor:   eor #$00
                eor $dd00
                cli
                sta loadbuffer,x
                inx
                bne fastload_fbloop

fillbuffer_common:
                stx bufferstatus                ;X is 0 here
                ldx #$fe
                lda loadbuffer                  ;Full 254 bytes?
                bne fastload_fullbuffer
                ldx loadbuffer+1                ;End of load?
                bne fastload_noloadend
                stx fileopen                    ;Clear fileopen indicator
                lda loadbuffer+2                ;Read the return/error code
                sta fileclosed+1
fastload_noloadend:
                dex
fastload_fullbuffer:
                stx fastload_endcomp+1
fileclosed:     lda #$00
                sec
                rts

;-------------------------------------------------------------------------------
; GETBYTE
;
; Gets a byte from an opened file.
;
; Parameters: -
; Returns: C=0 OK, A contains byte
;          C=1 File stream ended. A contains the error code:
;              $00 - OK, end of file
;              $01 - Sector read error (only with fastloading)
;              $02 - File not found
; Modifies: A
;-------------------------------------------------------------------------------

getbyte:        lda fileopen
                beq fileclosed
                stx getbyte_restx+1
                sty getbyte_resty+1
getbyte_fileopen:
                lda fastloadstatus
                lsr
                bcc slowload_getbyte
fastload_getbyte:
                ldx bufferstatus
                lda loadbuffer+2,x
                inx
fastload_endcomp:cpx #$00                       ;Reach end of buffer?
                stx bufferstatus
                bcc getbyte_restx
                pha
                jsr fastload_fillbuffer
                pla
getbyte_done:   clc
getbyte_restx:  ldx #$00
getbyte_resty:  ldy #$00
                rts

slowload_getbyte:
                jsr chrin
                ldx status
                beq getbyte_done
                pha
                txa
                and #$03
                sta fileclosed+1        ;EOF - store return code
                dec fileopen
                jsr close_kernaloff
                pla
                ldx fileclosed+1        ;Check return code, if nonzero,
                cpx #$01                ;return with carry set and return
                bcc getbyte_restx       ;code in A
                txa
                bcs getbyte_restx

                if HISCORE_SUPPORT>0
;-------------------------------------------------------------------------------
; SAVEHISCORES
;
; Uninitializes fastloader and saves the hiscore/configuration file.
; Fastloader will be re-initted next time when it is needed.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

savehiscores:   jsr kernalon
                lda fastloadstatus
                and #$fe
                sta fastloadstatus              ;Mark fastloader as uninitted
                lda #HINAMELENGTH+3
                ldx #<scratch
                ldy #>scratch
                jsr setnam
                lda #$0f                        ;Delete the old file
                ldy #$0f
                jsr setlfsdevice
                jsr open
                lda #$0f
                jsr close
                jsr setlfsdevice
                jsr sethiscorename
                lda #<hiscores
                sta destlo
                lda #>hiscores
                sta desthi
                ldx #<(hiscores+HISCORESIZE+CONFIGSIZE)
                ldy #>(hiscores+HISCORESIZE+CONFIGSIZE)
                lda #destlo
                jsr save
                jmp kernaloff

;-------------------------------------------------------------------------------
; SETHISCORENAME
;
; Subroutine for setting the hiscore name with SETNAM for loading/saving.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

sethiscorename: lda #$00
                sta messages                    ;Disable Kernal messages
                lda #HINAMELENGTH
                ldx #<hiscorename
                ldy #>hiscorename
                jmp setnam
                endif

;-------------------------------------------------------------------------------
; SETLFSDEVICE
;
; Gets the last used device number and performs a SETLFS.
;
; Parameters: -
; Returns: -
; Modifies: X
;-------------------------------------------------------------------------------

setlfsdevice:   ldx fa
                jmp setlfs

;-------------------------------------------------------------------------------
; KERNALON
;
; Switches KERNAL on to prepare for slow loading. Saves state of $01.
;
; Parameters: -
; Returns: -
; Modifies: A,X
;-------------------------------------------------------------------------------

kernalon:       lda $01
                sta kernaloff+1
                lda #$36
                sta $01
                lda fastloadstatus      ;In fakeIRQ-mode, can skip
                bmi kernalon_nosilence
                lda #$00
                sta $d015               ;To be absolutely sure: sprites off!
                sta $d404               ;Sound channels off
                sta $d404+7
                sta $d404+14
kernalon_nosilence:
                cli
                rts

;-------------------------------------------------------------------------------
; CLOSE_KERNALOFF
;
; Closes file 2 and then restores state of $01.
;
; Parameters: -
; Returns: -
; Modifies: A
;-------------------------------------------------------------------------------

close_kernaloff:lda #$02
                jsr close
                jsr clrchn

;-------------------------------------------------------------------------------
; KERNALOFF
;
; Restores state of $01.
;
; Parameters: -
; Returns: -
; Modifies: A
;-------------------------------------------------------------------------------

kernaloff:      lda #$36
                sta $01
il_ok:          rts

nmi:            rti

;-------------------------------------------------------------------------------
; INITFASTLOADER
;
; Uploads the fastloader to disk drive memory and starts it.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

MAXFILES        = 128           ;Max. files to buffer

RETRIES         = 5             ;Retries when reading a sector

IRQ_SPEED       = $28           ;$1c07 (head movement speed)
                                ;Safe range $20-$28+ (Graham)

MW_DATA_LENGTH  = 32            ;Bytes in one M-W command

iddrv0          = $12           ;Disk drive ID (1541 only)
id              = $16           ;Disk ID (1541 only)

buf             = $0400         ;Sector data buffer
serial          = $1800         ;Serial bus register (1541)

drv_filetrk     = $0300         ;Drive memory map
drv_filesct     = $0380
drvstart        = $0452
drv_fileletter1 = $0700
drv_fileletter2 = $0780

initialize      = $d005         ;1541 only

initfastload:   lda usefastload
                beq ifl_done
                lda fastloadstatus          ;Check if already initialized
                bne ifl_done
                lda #>drivecodestart
                sta ifl_senddata+2
                lda #<drvstart
                sta ifl_mwstring+2
                lda #>drvstart
                sta ifl_mwstring+1
                lda #$aa
                sta $a5
                jsr kernalon
                ldy #$00
                lda #(drivecodeend-drivecodestart+MW_DATA_LENGTH-1)/MW_DATA_LENGTH
                sta loadtempreg           ;Number of "packets" to send
                bne ifl_nextpacket
ifl_sendmw:     lda ifl_mwstring,x        ;Send M-W command (backwards)
                jsr ciout
                dex
                bpl ifl_sendmw
                ldx #MW_DATA_LENGTH
ifl_senddata:   lda drivecodestart,y      ;Send one byte of drivecode
                jsr ciout
                iny
                bne ifl_notover
                inc ifl_senddata+2
ifl_notover:    inc ifl_mwstring+2        ;Also, move the M-W pointer forward
                bne ifl_notover2
                inc ifl_mwstring+1
ifl_notover2:   dex
                bne ifl_senddata
                jsr unlsn                 ;Unlisten to perform the command
ifl_nextpacket: lda fa                    ;Set drive to listen
                jsr listen
                lda status                ;Quit if serial error (probably IDE64)
                cmp #$c0
                beq ifl_noserial
                lda #$6f
                jsr second
                ldx #$05
                dec loadtempreg           ;All "packets" sent?
                bpl ifl_sendmw
                dex
ifl_sendme:     lda ifl_mestring,x        ;Send M-E command (backwards)
                jsr ciout
                dex
                bpl ifl_sendme
                jsr unlsn
                jsr kernaloff
                lda $a5                   ;Serial delay counter untouched?
                cmp #$aa
                beq ifl_noserial          ;Probably fast drive emulation then
                lda #$01                  ;Fastloader (ordinary mode) active
                sta fastloadstatus
ifl_done:       rts

ifl_noserial:   lda #$80                  ;Fake-IRQload mode
                sta fastloadstatus
                rts

;-------------------------------------------------------------------------------
; DRIVECODE - Code executed in the disk drive.
;-------------------------------------------------------------------------------

drivecodestart:                           ;Address in C64's memory
                rorg drvstart             ;Address in diskdrive's memory

                lda $fea0                 ;Recognize drive family
                ldx #3                    ;(from Dreamload)
drv_floop:      cmp drv_family-1,x
                beq drv_ffound
                dex                       ;If unrecognized, assume 1541
                bne drv_floop
                beq drv_idfound
drv_ffound:     lda drv_idloclo-1,x
                sta drv_idlda+1
                lda drv_idlochi-1,x
                sta drv_idlda+2
drv_idlda:      lda $fea4                 ;Recognize drive type
                ldx #3                    ;3 = CMD HD
drv_idloop:     cmp drv_id-1,x            ;2 = CMD FD
                beq drv_idfound           ;1 = 1581
                dex                       ;0 = 1541
                bne drv_idloop
drv_idfound:    stx drv_drivetype+1       ;Store drive type
                lda drv_1800lo,x
                sta drv_patch1800lo+1
                lda drv_1800hi,x
                sta drv_patch1800hi+1
                ldy #10
drv_patchloop:  ldx drv_1800ofs,y
drv_patch1800lo:lda #$00                  ;Patch all $1800 accesses
                sta drvmain+1,x
drv_patch1800hi:lda #$00
                sta drvmain+2,x
                dey
                bpl drv_patchloop
                ldx drv_drivetype+1       ;On 1541, speedup controller IRQs
                bne drv_skip1c07          ;and copy the 1MHz send code
                lda #IRQ_SPEED
                sta $1c07
                ldy #drv_1mhzsenddone-drv_1mhzsend-1
drv_copysendcode:
                lda drvend,y
                sta drv_2mhzsend,y
                dey
                bpl drv_copysendcode

drv_skip1c07:   lda drv_dirtrklo,x        ;Patch directory
                sta drv_dirtrk+1
                lda drv_dirtrkhi,x
                sta drv_dirtrk+2
                lda drv_dirsctlo,x
                sta drv_dirsct+1
                lda drv_dirscthi,x
                sta drv_dirsct+2
                lda drv_execlo,x          ;Patch job exec address
                sta drv_execjsr+1
                lda drv_exechi,x
                sta drv_execjsr+2
                lda drv_jobtrklo,x        ;Patch job track/sector
                sta drv_readtrk+1
                clc
                adc #$01
                sta drv_readsct+1
                lda drv_jobtrkhi,x
                sta drv_readtrk+2
                adc #$00
                sta drv_readsct+2
                lda drv_ledenabled,x             ;Patch LED flashing
                sta drv_led
                lda drv_ledbit,x
                sta drv_led+1
                lda drv_ledadrhi,x
                sta drv_ledacc1+2
                sta drv_ledacc2+2

drvmain:        jsr drv_cachedir          ;Always cache on startup
drv_loop:       cli
                ldx #$01
drv_nameloop:   ldy #$08                  ;Bit counter
drv_namebitloop:
drv_1800ac0:    lda $1800
                bpl drv_noquit            ;Quit if ATN is low
drv_drivetype:  lda #$00                  ;1541 = exit through Initialize
                bne drv_not1541           ;Others = exit through RTS
                lda #$3a                  ;Restore default speed
                sta $1c07
                jmp initialize
drv_not1541:    rts

drv_noquit:     and #$05                  ;Wait for CLK or DATA going low
                beq drv_namebitloop
                lsr                       ;Read the data bit
                lda #$02	              ;Pull the other line low to acknowledge
                bcc drv_namezero
                lda #$08
drv_namezero:   ror drv_filename,x        ;Store the data bit
drv_1800ac1:    sta $1800
drv_namewait:
drv_1800ac2:    lda $1800                 ;Wait for either line going high
                and #$05
                cmp #$05
                beq drv_namewait
                lda #$00
drv_1800ac3:    sta $1800	              ;Set both lines high
                dey
                bne drv_namebitloop       ;Loop until all bits have been received
                sei                       ;Disable interrupts after first byte
                dex
                bpl drv_nameloop

                lda drv_dircached         ;Cache directory if necessary
                bne drv_dircacheok
                jsr drv_cachedir
drv_dircacheok:
drv_searchname: lda drv_fileletter1,y
                cmp drv_filename
                bne drv_searchnext
                lda drv_fileletter2,y
                cmp drv_filename+1
                beq drv_found
drv_searchnext: iny
                cpy drv_dircached
                bcc drv_searchname
drv_filenotfound:
                lda #$00                  ;If file not found, reset caching
                sta drv_dircached
                ldx #$02                  ;Return code $02 = File not found
drv_loadend:    stx buf+2
                lda #$00
                sta buf
                sta buf+1
                beq drv_sendblk

drv_found:      ldx drv_filetrk,y
                lda drv_filesct,y
                jmp drv_firstsect

drv_nextsect:   ldx buf,y                 ;File found, get starting T&S
                beq drv_loadend           ;At file's end? (return code $00 = OK)
                lda buf+1,y
drv_firstsect:  tay
                jsr drv_readsector        ;Read the data sector
                bcs drv_loadend
drv_sendblk:    ldy #$00
                ldx #$02
drv_sendloop:   lda buf,y
                lsr
                lsr
                lsr
                lsr
drv_1800ac4:    stx $1800               ;Set DATA=low for first byte, high for
                tax                     ;subsequent bytes
                lda drv_sendtbl,x
                pha
                lda buf,y
                and #$0f
                tax
                lda #$04
drv_1800ac5:    bit $1800               ;Wait for CLK=low
                beq drv_1800ac5
                lda drv_sendtbl,x
drv_1800ac6:    sta $1800

        ; 2MHz send timing code from ULoad3 by MagerValp

drv_2mhzsend:   jsr drv_delay18
                nop
                asl
                and #$0f
drv_1800ac7:    sta $1800
                cmp ($00,x)
                nop
                pla
drv_1800ac8:    sta $1800
                cmp ($00,x)
                nop
                asl
                and #$0f
drv_1800ac9:    sta $1800
                ldx #$00
                iny
                bne drv_sendloop
                jsr drv_delay12
drv_1800ac10:   stx $1800                 ;Finish send: DATA & CLK both high

drv_senddone:   lda buf                   ;First 2 bytes zero marks end of loading
                ora buf+1                 ;(3rd byte is the return code)
                bne drv_nextsect
                jmp drv_loop

drv_readsector: jsr drv_led
drv_readtrk:    stx $1000
drv_readsct:    sty $1000
                ldy #RETRIES            ;Retry counter
drv_retry:      lda #$80
                ldx #1
drv_execjsr:    jsr drv_1541exec        ;Exec buffer 1 job
                cmp #$02                ;Error?
                bcc drv_success
drv_skipid:     dey                     ;Decrease retry counter
                bne drv_retry
drv_failure:    ldx #$01                ;Return code $01 - Read error
drv_success:    sei                     ;Make sure interrupts now disabled
drv_led:        lda #$08                ;Flash the drive LED
drv_ledacc1:    eor $1c00
drv_ledacc2:    sta $1c00
                rts

drv_cachedir:
drv_dirtrk:     ldx $1000
drv_dirsct:     ldy $1000                 ;Read disk directory
drv_dirloop:    jsr drv_readsector        ;Read sector
                bcs drv_dircachedone      ;If failed, abort caching
                ldy #$02
drv_nextfile:   lda buf,y                 ;File type must be PRG
                and #$83
                cmp #$82
                bne drv_skipfile
                lda buf+5,y               ;Must be two-letter filename
                cmp #$a0                  ;(MW4 datafiles)
                bne drv_skipfile
                ldx drv_dircached
                cpx #MAXFILES
                bcs drv_dircachedone
                lda buf+1,y
                sta drv_filetrk,x
                lda buf+2,y
                sta drv_filesct,x
                lda buf+3,y
                sta drv_fileletter1,x
                lda buf+4,y
                sta drv_fileletter2,x
                inc drv_dircached
drv_skipfile:   tya
                clc
                adc #$20
                tay
                bcc drv_nextfile
                ldy buf+1                 ;Go to next directory block, until no
                ldx buf	                  ;more directory blocks
                bne drv_dirloop
drv_dircachedone:
                rts

drv_1541exec:   tax
                cli                       ;Allow interrupts & execute command
                stx $01
drv_1541execwait:
                lda $01
                bmi drv_1541execwait
                pha
                ldx #$02
drv_checkid:    lda id-1,x                ;Check for disk ID change
                cmp iddrv0-1,x            ;(1541 only)
                beq drv_idok
                sta iddrv0-1,x
                lda #$00                  ;If changed, force recache of dir
                sta drv_dircached
drv_idok:       dex
                bne drv_checkid
                pla
                rts

drv_fdexec:     jsr $ff54                 ;FD2000 fix By Ninja
                lda $03
                rts

drv_delay18:    cmp ($00,x)
drv_delay12:    rts

drv_1541dirtrk: dc.b 18
drv_1541dirsct: dc.b 1
drv_1581dirsct: dc.b 3

drv_dircached:  dc.b 0

drv_sendtbl:    dc.b $0f,$07,$0d,$05
                dc.b $0b,$03,$09,$01
                dc.b $0e,$06,$0c,$04
                dc.b $0a,$02,$08,$00

drv_filename:

drv_family:     dc.b $43,$0d,$ff
drv_idloclo:    dc.b $a4,$c6,$e9
drv_idlochi:    dc.b $fe,$e5,$a6
drv_id:         dc.b "8","F","H"

drv_1800ofs:    dc.b drv_1800ac0-drvmain
                dc.b drv_1800ac1-drvmain
                dc.b drv_1800ac2-drvmain
                dc.b drv_1800ac3-drvmain
                dc.b drv_1800ac4-drvmain
                dc.b drv_1800ac5-drvmain
                dc.b drv_1800ac6-drvmain
                dc.b drv_1800ac7-drvmain
                dc.b drv_1800ac8-drvmain
                dc.b drv_1800ac9-drvmain
                dc.b drv_1800ac10-drvmain

drv_1800lo:     dc.b <$1800,<$4001,<$4001,<$8000
drv_1800hi:     dc.b >$1800,>$4001,>$4001,>$8000

drv_dirtrklo:   dc.b <drv_1541dirtrk,<$022b,<$54,<$2ba7
drv_dirtrkhi:   dc.b >drv_1541dirtrk,>$022b,>$54,>$2ba7
drv_dirsctlo:   dc.b <drv_1541dirsct,<drv_1581dirsct,<$56,<$2ba9
drv_dirscthi:   dc.b >drv_1541dirsct,>drv_1581dirsct,>$56,>$2ba9

drv_execlo:     dc.b <drv_1541exec,<$ff54,<drv_fdexec,<$ff4e
drv_exechi:     dc.b >drv_1541exec,>$ff54,>drv_fdexec,>$ff4e

drv_jobtrklo:   dc.b <$0008,<$000d,<$000d,<$2802
drv_jobtrkhi:   dc.b >$0008,>$000d,>$000d,>$2802

drv_ledenabled:  dc.b $a9,$a9,$a9,$60
drv_ledbit:      dc.b $08,$40,$40,$00
drv_ledadrhi:    dc.b $1c,$40,$40,$40

drvend:
                rorg drv_2mhzsend

drv_1mhzsend:   asl
                and #$0f
drv_1800ac7b:   sta $1800
                pla
drv_1800ac8b:   sta $1800
                asl
                and #$0f
drv_1800ac9b:   sta $1800
                ldx #$00
                iny
                bne drv_sendloop
                nop
drv_1800ac10b:  stx $1800                 ;Finish send: DATA & CLK both high
                jmp drv_senddone
drv_1mhzsenddone:

                rend

drivecodeend:

ifl_mwstring:   dc.b MW_DATA_LENGTH,>drvstart, <drvstart,"W-M"
ifl_mestring:   dc.b >drvstart, <drvstart, "E-M"


;-------------------------------------------------------------------------------
; Filename (in short name mode) and hiscore filename
;-------------------------------------------------------------------------------

                if LONG_NAMES=0
filename:       dc.b "00*"
                endif

                if HISCORE_SUPPORT>0
scratch:        dc.b "S0:"
hiscorename:    dc.b "HI"
                endif

                org cfg_usefastload

usefastload:    dc.b 1
showloadpic:    dc.b 1

                org maincodestart-6

                jmp loadfile_exomizer
                jmp savehiscores

;-------------------------------------------------------------------------------
; Disposable portion of loader (routines only needed when initializing)
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
; INITLOADER
;
; Inits the loadersystem. Needs to be called only once in the beginning.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

initloader:     sta $d07a                       ;SCPU to slow mode
                lda #<nmi                       ;Set NMI vector to prevent
                sta $0318                       ;runstop-restore during
                sta $fffa                       ;loading
                lda #>nmi
                sta $0319
                sta $fffb
                ldy #$00
                lda #$81                        ;Run Timer A once to disable NMI from Restore keypress
                sta $dd0d                       ;Timer A interrupt source
                lda #$01                        ;Timer A count ($0001)
                sta $dd04
                sty $dd05
                lda #%00011001                  ;Run Timer A in one-shot mode
                sta $dd0e
                sty fastloadstatus              ;Initial fastload status = off
                sty fileopen                    ;No file initially open
                sei                             ;Detect PAL/NTSC by measuring
il_detectntsc1: ldx $d011                       ;greatest rasterline number
                bmi il_detectntsc1
il_detectntsc2: ldx $d011
                bpl il_detectntsc2
il_detectntsc3: cpy $d012
                bcs il_detectntsc4
                ldy $d012
il_detectntsc4: ldx $d011
                bmi il_detectntsc3
                cli
                cpy #$20
                bcc il_isntsc                   ;PAL
                lda #$2c                        ;Adjust 2-bit fastload transfer
                sta fastload_delay              ;delay

il_isntsc:
                if HISCORE_SUPPORT>0
;-------------------------------------------------------------------------------
; LOADHISCORES
;
; Loads the hiscore/configuration file.
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

loadhiscores:   ldy #$00                        ;Load to user-defined address
                jsr setlfsdevice
                jsr sethiscorename
                lda #$00
                ldx #<hiscores
                ldy #>hiscores
                jmp load
                endif
