;ͻ
;Metal Warrior 2 by Cadaver                                                   
;Started in 8/1999!                                                           
;ͼ

                include zeropage.s
                include define.s

                processor 6502
                org maincodestart

MW2_START:

;Ŀ
;MWSTART                                                                      
;                                                                             
;Here begins the main program!                                                
;

mwstart:        ldx #$ff                        ;Mark leveldata as destroyed
                txs
                cld
                stx loadedlevel
                stx loadedsprites
                lda cfg_usefastload
                and cfg_showloadpic
                beq nofade
                jsr $c003                       ;Fade titlemusic now
nofade:
                lda $d011
                and #$e0                        ;Blank screen now
                sta $d011
                ldx #"P"
                ldy #"2"
                jsr loader_loadfile             ;Load playersprites
                jsr getplayercolors

                lda ntscflag                    ;Don't do NTSC modification
                bne mwstart_ntscdone            ;twice
                inc ntscflag
                lda $02a6
                bne mwstart_ntscdone            ;PAL
                dec r2_jump1+1
                dec r2_jump2+1
mwstart_ntscdone:
                jsr initsprites
                jsr initsfx
                jsr initvideo                   ;Set border color etc.
                jsr initraster                  ;Init raster & switch kernal off
                jsr initcontrols
                jsr initmsg
                lda #$01
                sta titlechoice                 ;Reset title choice
mainloop:       lda #$00
mainloop2:      jsr titlescreen
                lda titlechoice
                beq introduction
                cmp #$02
                beq startpwd
startgame:      jsr initgame
startgame2:     jsr initplayer

                jsr updatestatus
                jsr loadleveldata
                jsr initworld
                jsr initactors
                jsr initexplosion
                jsr initsprites
                jmp newlife
startpwd:       jsr enterpassword
                jsr initgame
                jsr checkpassword
                bcc mainloop
                bcs startgame2
introduction:   lda #<introscript
                sta csptrlo
                lda #>introscript
                sta csptrhi
                jsr runscript
                jmp mainloop

;Ŀ
;CHECKPAUSE                                                                   
;                                                                             
;A subroutine to check pausing & quitting & sound toggling.                   
;Note! In quitting, doesn't RTS but goes directly to gameover routine.        
;

checkpause:     lda keyval
                cmp #KEY_S
                bne cp_nosound
                jsr togglefx
                lda soundmode
                clc
                adc #23
                sta msgnum
                rts
cp_nosound:     cmp #KEY_RUNSTOP
                bne cp_not
                lda pausemode
                eor #$01
                sta pausemode
                clc
                adc #21
                sta msgnum
cp_not2:        rts
cp_not:         cmp #KEY_Q
                bne cp_not2
                lda pausemode
                beq cp_not2
                pla
                pla
                lda #$00

;Ŀ
;GAMEOVER                                                                     
;                                                                             
;Displays game over screen and performs hiscore entry. Parameters:            
;A=0 Game over by quitting                                                    
;A=1 Game over by running out of lives (different picture in each case)       
;

gameover:       sta gameovertext+1
                sta gameoverpic+1
                lda #<gameoverscript
                sta csptrlo
                lda #>gameoverscript
                sta csptrhi
                jsr runscript
                jsr calcpassword
                lda #<passwordtxt
                sta srclo
                lda #>passwordtxt
                sta srchi
                ldy #15
                jsr printtextc
                ldy #16
                jsr printpassword
gameoverwait:   jsr waitraster0
                jsr getcontrols
                jsr getfireclick
                bcc gameoverwait
                jsr fadetune
aftervictory:   jsr blankgamescreen
                jsr hiscore
                beq gameovernosave
                jsr savehiscore
                lda #$01
gameovernosave: jmp mainloop2

;Ŀ
;ENTERGAMELOOP                                                                
;                                                                             
;Here begins main game loop.                                                  
;

entergameloop:  lda #$00
                sta pausemode
                sta r1count
gameloop:       lda r1count
                cmp #$02
                bcc gameloop
                lda #$00
                sta r0count
                sta r1count
                sta scrollsx
                sta scrollsy
                jsr getcontrols
                jsr checkdeath
                bcs gameover
                jsr checkpause
                lda pausemode
                bne gameloop_pause
                jsr bganim
                jsr bossmusic
                jsr addactborder                ;Note: the order of these
                jsr enemygenerator
                jsr moveactors                  ;routines has been carefully
                jsr removefaractors             ;thought out. Do not change!
                jsr changeweapon
                jsr playershoot
                jsr movebullets
                jsr enemydamage
                jsr playerdamage
                jsr checkscroll
                jsr checkmaplimits
                jsr scrollsprites
                jsr flashitems
                jsr updexplosion
gameloop_pause: jsr msgroutine
                jsr updatestatus
                jsr doactors
                jsr drawexplosion
                jsr dosprites
gameloop_delay: lda r0count
                beq gameloop_delay
                jsr erasebullets
                jsr doorroutine
                jsr preparebullets
                jsr switchsprites
                jsr doscroll
                jsr drawbullets
                lda gamecomplete
                bne victory
                lda csptrlo
                ora csptrhi
                beq gameloop

        ;This is the routine to show an in-game cutscene, like getting
        ;some important object etc.

gameloop_cutscene:
                ldx loadedsprites                 ;Store loaded spritefile
                stx gameloop_restspr+1
                jsr runscript                     ;Run the script
                jsr blankgamescreen
gameloop_restspr:
                lda #$00
                bmi gameloop_skipspr
                jsr loadsprites                   ;Then load the game sprites
gameloop_skipspr:                                 ;back
                jmp backtogame

victory:        jsr countbonuses
                lda #<victoryscript
                sta csptrlo
                lda #>victoryscript
                sta csptrhi
                jsr runscript
                jmp aftervictory

                include control.s
                include sprite.s
                include screen.s
                include raster.s
                include load.s
                include music.s
                include title.s
                include actor.s
                include weapon.s
                include item.s
                include player.s
                include enemy.s
                include level.s
                include data.s

                org MUSIC
                incbin music.bin

                org TEXTCHARS
                incbin scorescr.chr

                ds.b 20*40,32
                include scorescr.s
                org TEXTCHARS+$7f8
                ds.b $8,$a0
                ds.b 64,0

