;ͻ
;Metal Warrior 2 Title Screen, Hiscore, Cutscene, Script, Message routines    
;Started in 10/1999!                                                          
;ͼ

CUTSPRY         = 62
CUTSPRX         = 136
TEXTDELAY       = 4

S_LOADCUTSCENE  = 0
S_SHOWPICTURE   = 1
S_SHOWTEXT      = 2
S_PLAYMUSIC     = 3
S_WAITFIRE      = 4
S_EXIT          = 5
S_FADEMUSIC     = 6
S_SHOP          = 7
S_DELAY         = 8
S_SETITEM       = 9
S_CLEARITEM     = 10
S_SETPLOTBIT    = 11
S_CLEARPLOTBIT  = 12
S_CHECKITEM     = 13
S_CHECKPLOTBIT  = 14
S_BRANCH        = 15
S_JUMP          = 16
S_CALLCODE      = 17
S_WARPPLAYER    = 18
S_SCROLL        = 19




TITLE_START:

;Ŀ
;TITLESCREEN                                                                  
;                                                                             
;Displays title screen, hiscores, instructions etc. until fire is pressed     
;                                                                             
;Parameters: A:Screen to start from                                           
;Returns: A:Choice that was made in the menu                                  
;Modifies: A,X,Y                                                              
;

titlescreen:    sta titlecount
                lda #MUSIC_TITLE
                jsr playtune
titleloop:      jsr titleprepare
                lda titlecount
                asl
                tax
                lda titletbl,x
                sta titlejsr+1
                lda titletbl+1,x
                sta titlejsr+2
titlejsr:       jsr $0000
                lda #$00
                sta tempval3
                sta tempval4
                sta cheatletter
titlewait:      jsr waitraster0
                jsr random                      ;Call random to make games
                jsr getcontrols                 ;different

                ldx cheatletter
                lda keyval
                cmp #$ff
                beq tcheat2
                cmp cheatstring,x
                bne tcheat1
                inx
                cpx #$0b
                bcc tcheat2
                ldx #$00
cheatflash:     inc $d020
                inx
                bne cheatflash
                lda cheaton
                eor #$01
                sta cheaton
tcheat1:        ldx #$00
tcheat2:        stx cheatletter

                lda titlecount                  ;Screen 0 is the menu
                beq titlemenu
                lda joystick                    ;If joystick moved in other
                bne title_reset                 ;screens, go back to menu
title_noctrl:   inc tempval3
                bne title_nohi
                inc tempval4
title_nohi:     lda tempval4
                cmp #$02                        ;Delay between screens is 640
                bcc titlewait                   ;frames
                lda tempval3
                cmp #$80
                bcc titlewait
                lda titlecount
                adc #$00                        ;Carry=1
                cmp #$05
                bcc title_notover
title_reset:    lda #$00
title_notover:  sta titlecount
                jmp titleloop
titlemenu:      ldx titlechoice
                ldy screenrowtbllo,x
                lda #$20                        ;Clear the select-sign
                sta TEXTSCREEN+14*40+11,y
                jsr getfireclick                ;Was fire pressed?
                bcc title_nofire
                rts
title_nofire:   lda joystick
                and #JOY_UP
                beq title_notup
                lda prevjoy
                and #JOY_UP
                bne title_notup
                dec titlechoice
                jmp title_movecommon
title_notup:    lda joystick
                and #JOY_DOWN
                beq title_notdown
                lda prevjoy
                and #JOY_DOWN
                bne title_notdown
                inc titlechoice
title_movecommon:
                lda #$00                        ;Reset the delay-counter
                sta tempval3
                sta tempval4
                ldx titlechoice
                bpl title_notneg
                lda #$02
                bne title_choiceok
title_notneg:   cpx #$03
                bcc title_notdown
title_choiceok: sta titlechoice
title_notdown:  lda tempval3
                and #$10
                bne title_nosign
                ldx titlechoice                 ;Draw the select-sign
                ldy screenrowtbllo,x
                lda #$1f
                sta TEXTSCREEN+14*40+11,y
title_nosign:   jmp title_noctrl

printinfo:      lda #<titletxt1
                sta srclo
                lda #>titletxt1
                sta srchi
                jmp prctrlstart

printhiscore:   lda #<hiscoretxt
                sta srclo
                lda #>hiscoretxt
                sta srchi
                ldy #$04
                jsr printtextc
                lda #$00
                sta tempval1
prhscloop:      lda tempval1
                cmp #$0a
                bcs prhscdone
                clc
                adc #$07
                tay
                jsr printhscrow
                inc tempval1
                jmp prhscloop
prhscdone:      rts

printhscrow:    lda tempval1
                jsr hscmultiply
                clc
                adc #<hiscorenames
                sta srclo
                lda #>hiscorenames
                adc #$00
                sta srchi
                ldx #$09
                jsr printtext
prhscloop2:     ldx tempval1
                lda hiscoredigit4,x
                jsr prhscdigits
                lda hiscoredigit3,x
                jsr prhscdigits
                lda hiscoredigit2,x
                jsr prhscdigits
                lda hiscoredigit1,x
                jsr prhscdigits
                rts

prhscdigits:    pha
                lsr
                lsr
                lsr
                lsr
                clc
                adc #"0"
                sta (destlo),y
                iny
                pla
                and #$0f
                adc #"0"
                sta (destlo),y
                iny
                rts

printstory:     lda #<storytxt1
                sta srclo
                lda #>storytxt1
                sta srchi
prstorystart:   ldy #$04
                jsr printtextc
                ldy #$06
prstoryloop:    sty tempval1
                ldx #$00
                jsr printtext
                ldy tempval1
                iny
                cpy #$12
                bcc prstoryloop
                rts

printgameplay:  lda #<gametxt1
                sta srclo
                lda #>gametxt1
                sta srchi
                jmp prstorystart

printcontrols:  lda #<ctrltxt1
                sta srclo
                lda #>ctrltxt1
                sta srchi
prctrlstart:    ldy #$04
prctrlloop:     sty tempval1
                jsr printtextc
                ldy tempval1
                iny
                cpy #$12
                bcc prctrlloop
                rts

titletbl:       dc.w printinfo
                dc.w printhiscore
                dc.w printstory
                dc.w printgameplay
                dc.w printcontrols

;Ŀ
;DRAWLOGO                                                                     
;                                                                             
;Draws the "Metal Warrior II" logo to the upper part of text screen.          
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

titleprepare:   jsr waitraster0
                jsr cleartextscreen
drawlogo:       ldx #27
dl_loop:        lda logo,x                      ;Draw metal warrior logo
                sta TEXTSCREEN+6,x
                lda logo+28,x
                sta TEXTSCREEN+1*40+6,x
                lda logo+56,x
                sta TEXTSCREEN+2*40+6,x
                dex
                bpl dl_loop
                lda #SCRMODE_LOGO               ;Set the logo rastereffect on
                sta screenmode
                rts

;Ŀ
;LOADCUTSCENE                                                                 
;                                                                             
;Loads a cutscene's sprite & text datas.                                      
;                                                                             
;Parameters: A:Cutscene number                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

loadcutscene:   clc
                adc #"0"
                tay
                ldx #"C"
                jsr load                        ;Perform loading
                lda #$ff                        ;Set levelsprites as destroyed
                sta loadedsprites
                jmp getenemycolors              ;Set spritecolors

;Ŀ
;SHOWPICTURE                                                                  
;                                                                             
;Shows a cutscene picture.                                                    
;                                                                             
;Parameters: A:Picture number within cutscene                                 
;Returns: -                                                                   
;Modifies: X,Y                                                                
;

showpicture:    sta tempval4
                asl                             ;Multiply picture number with
                asl                             ;4
                sta tempval1
                jsr initsprites
                jsr waitraster0
                jsr cleartextscreen
                lda #$0c
                sta numspr
                lda tempval1
                asl                             ;Shift one more time to get x8
                adc tempval1                    ;Add the x4 value to get x12
                adc LEVELSPRITES                ;Add the first picsprite frame
                tay                             ;Framenumber ready!
                ldx #$00
                lda #CUTSPRY
                sta tempval1
spic_newrow:    lda #CUTSPRX                    ;Display 4x3 sprites
                sta tempval2
                lda #$00
                sta tempval3
spic_loop:      lda #$00
                sta spryh,x
                sta sprfls,x
                lda tempval1
                sta spryl,x
                lda tempval2
                sta sprxl,x
                clc
                adc #$18
                sta tempval2
                lda tempval3
                sta sprxh,x
                adc #$00
                sta tempval3
                tya
                sta sprf,x
                iny
                inx
                txa
                and #$03
                bne spic_loop
                cpx #$0c
                bcs spic_done
                lda tempval1
                adc #21                         ;Carry=0
                sta tempval1
                bne spic_newrow
spic_done:      jsr dosprites
                jsr switchsprites
                lda #SCRMODE_CUTS
                sta screenmode
                lda tempval4
                rts

;Ŀ
;SHOWTEXT                                                                     
;                                                                             
;Shows cutscene texts.                                                        
;                                                                             
;Parameters: A:Text number within cutscene                                    
;Returns: -                                                                   
;Modifies: X,Y                                                                
;

showtext:       sta tempval4
                jsr waitraster0
                jsr cleartextscreen
                lda tempval4
                asl
                tax
                lda LEVELSPRITES+2,x            ;Get text start address
                sta srclo
                lda LEVELSPRITES+3,x
                sta srchi
                lda #$0a                        ;Initial row number
                sta tempval1
shtxt_loop:     ldy #$00
                lda (srclo),y
                beq shtxt_end
                ldx #TEXTDELAY
shtxt_delay:    jsr waitraster0
                dex
                bne shtxt_delay
                ldx #$00
                ldy tempval1
                jsr printtext
                inc tempval1
                bne shtxt_loop
shtxt_end:      lda tempval4
                rts

;Ŀ
;PRINTPASSWORD                                                                
;                                                                             
;Prints out the password.                                                     
;                                                                             
;Parameters: Y:Row that is used                                               
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

printpassword:  lda #$02
                sta titlechoice           ;Default to Continue now
                lda #20-PASSWORDLENGTH
                clc
                adc screenrowtbllo,y
                sta destlo
                lda #>TEXTSCREEN
                adc screenrowtblhi,y
                sta desthi
                ldx #$00
                ldy #$00
ppwd_loop:      lda password,x
                lsr
                lsr
                lsr
                lsr
                jsr ppwd_letter
                lda password,x
                and #$0f
                jsr ppwd_letter
                inx
                cpx #PASSWORDLENGTH
                bcc ppwd_loop
                rts
ppwd_letter:    clc
                adc #$01
                sta (destlo),y
                iny
                rts

;Ŀ
;ENTERPASSWORD                                                                
;                                                                             
;Gets the password from player, with hex-digits mapped to letters A-P.        
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

enterpassword:  jsr fadetune
                jsr titleprepare
                ldy #$0a
                lda #<pwdentrytxt
                sta srclo
                lda #>pwdentrytxt
                sta srchi
                jsr printtextc
                lda #$00
                sta tempval3                    ;Tempval3 = cursor pos.
                sta tempval4                    ;Tempval4 = flashing counter
epwd_loop:      jsr waitraster0
                jsr getcontrols
                ldy #$0c
                jsr printpassword
                inc tempval4
                lda tempval4
                and #$10                        ;Flash cursor?
                bne epwd_noflash
                ldx tempval3
                lda #$20
                sta TEXTSCREEN+$0c*40+20-PASSWORDLENGTH,x
epwd_noflash:   lda keyval
                cmp #$ff
                beq epwd_loop
                tax
                lda asciitbl,x
                bmi epwd_del
                cmp #13
                bne epwd_notenter
                rts
epwd_notenter:  tay                             ;Y=ascii char
                lda tempval3
                cmp #PASSWORDLENGTH*2
                bcs epwd_loop
                lsr
                tax                             ;X=byte pos.
                tya
                sec
                sbc #"A"
                bcc epwd_loop
                cmp #$10
                bcs epwd_loop
epwd_digitok:   sta tempval2                    ;Store digit
                lda tempval3
                and #$01                        ;Low or high digit?
                bne epwd_lowdigit
epwd_highdigit: asl tempval2
                asl tempval2
                asl tempval2
                asl tempval2
                lda password,x
                and #$0f
                bcc epwd_orandstore
epwd_lowdigit:  lda password,x
                and #$f0
epwd_orandstore:ora tempval2
                sta password,x
                inc tempval3                    ;Increase cursor position
                bpl epwd_loop
epwd_del:       lda tempval3
                beq epwd_loop
                dec tempval3
                bpl epwd_loop

;Ŀ
;HISCORE                                                                      
;                                                                             
;This routine is called when game ends/player quits, and it handles the       
;"enter your name"-part.                                                      
;                                                                             
;Parameters: -                                                                
;Returns: A=0 no hiscore A=1 hiscore                                          
;Modifies: A,X,Y                                                              
;

hiscore:        jsr blankgamescreen
                ldx #$00                         ;Start from highest score
chsc_loop:      lda score+3                      ;Check each of the 4 bytes
                cmp hiscoredigit4,x
                beq chsc_check2
                bcs chsc_found
                bcc chsc_next
chsc_check2:    lda score+2
                cmp hiscoredigit3,x
                beq chsc_check3
                bcs chsc_found
                bcc chsc_next
chsc_check3:    lda score+1
                cmp hiscoredigit2,x
                beq chsc_check4
                bcs chsc_found
                bcc chsc_next
chsc_check4:    lda score
                cmp hiscoredigit1,x
                beq chsc_next
                bcs chsc_found
chsc_next:      inx
                cpx #$0a                        ;Reached bottom?
                bne chsc_loop
                lda #$00                        ;No hiscore
                rts
chsc_found:     stx tempval1                    ;Tempval1 = placement (0-9)
                txa
                jsr hscmultiply
                clc
                adc #$03
                sta tempval2                    ;and save
                cpx #$09                        ;If position is last then no
                beq hsc_skipshift               ;need to shift names&scores
                ldx #$08
hsc_shiftscore: lda hiscoredigit1,x             ;Shift scores down
                sta hiscoredigit1+1,x
                lda hiscoredigit2,x
                sta hiscoredigit2+1,x
                lda hiscoredigit3,x
                sta hiscoredigit3+1,x
                lda hiscoredigit4,x
                sta hiscoredigit4+1,x
                cpx tempval1
                beq hsc_ssdone
                dex
                bpl hsc_shiftscore
hsc_ssdone:     ldx #8*14+13
hsc_shiftname1: ldy #10
hsc_shiftname2: dex
                lda hiscorenames,x            ;Shift names down
                sta hiscorenames+14,x
                dey
                bne hsc_shiftname2
                cpx tempval2
                beq hsc_skipshift
                txa
                sec
                sbc #$04
                tax
                jmp hsc_shiftname1
hsc_skipshift:  ldx tempval1
                lda score                       ;Store player's points
                sta hiscoredigit1,x
                lda score+1
                sta hiscoredigit2,x
                lda score+2
                sta hiscoredigit3,x
                lda score+3
                sta hiscoredigit4,x
                ldy #$0a
                ldx tempval2
                lda #"."
hsc_clearname:  sta hiscorenames,x
                inx
                dey
                bne hsc_clearname
                lda #MUSIC_HISCORE              ;Play hiscore music
                jsr playtune
                jsr waitraster0
                jsr cleartextscreen
                jsr drawlogo
                lda #<enternametxt
                sta srclo
                lda #>enternametxt
                sta srchi
                ldy #$09                        ;Print the "enter name"
                jsr printtextc                  ;texts
                ldy #$0a
                jsr printtextc
                lda #$00
                sta tempval3
hsc_typeloop:   ldy #$0c
                ldx tempval1
                jsr printhscrow
hsc_waitkey:    jsr waitraster0
                jsr getcontrols
                lda keyval
                cmp #$ff
                beq hsc_waitkey
                tax
                lda asciitbl,x
                bmi hsc_del
                cmp #13
                bne hsc_notenter
                lda #$01
                rts
hsc_notenter:   tay
                lda tempval3
                cmp #$0a
                bcs hsc_typeloop
                clc
                adc tempval2
                tax
                tya
                sta hiscorenames,x
                inc tempval3
                bpl hsc_typeloop
hsc_del:        dec tempval3
                bpl hsc_notover
                lda #$00
                sta tempval3
hsc_notover:    lda tempval3
                clc
                adc tempval2
                tax
                lda #"."
                sta hiscorenames,x
                bne hsc_typeloop
hscmultiply:    asl                             ;Multiply place by 14
                asl
                asl
                asl
                sec
                sbc tempval1
                sbc tempval1
                rts

;Ŀ
;INITMSG                                                                      
;                                                                             
;Inits the message system (not much to do :-))                                
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

initmsg:        lda #$00
                sta msgtime
                sta msgnum
                jsr drawitems
                jmp updatestatus

;Ŀ
;MSGROUTINE                                                                   
;                                                                             
;Handles printing/removing of messages.                                       
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

msgroutine:     lda msgnum
                bne printmsg
                lda msgtime
                beq prmsg_finished
                dec msgtime
                bne prmsg_finished
                jmp drawitems
printmsg:       asl
                tax
                lda msgtbl-2,x
                sta srclo
                lda msgtbl-1,x
                sta srchi
                lda #30
                sta msgtime
                ldx #$00
                stx msgnum
                ldy #$00
prmsg_loop:     lda (srclo),y
                bne prmsg_notfinished
                lda #$20
                dey
prmsg_notfinished:
                and #$3f
                sta TEXTSCREEN+21*40+20,x
                iny
                inx
                cpx #19
                bcc prmsg_loop
prmsg_finished: rts

;Ŀ
;RUNSCRIPT                                                                    
;                                                                             
;Runs a cutscene/conversation/whatever script.                                
;                                                                             
;Parameters: csptrlo, csptrhi                                                 
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

runscript:
rscr_loop:      ldy #$00                            ;Get command
                lda (csptrlo),y
                asl
                tax
                lda rscr_jumptbl,x
                sta rscr_jsr+1
                lda rscr_jumptbl+1,x
                sta rscr_jsr+2
                iny                                 ;Increase Y for parameter
rscr_jsr:       jsr $0000                           ;Perform command
rscr_next:      clc                                 ;Upon return from command,
                adc csptrlo                         ;A holds command length
                sta csptrlo
                bcc rscr_loop
                inc csptrhi
                jmp rscr_loop
rscr_jumptbl:   dc.w rscr_loadcutscene
                dc.w rscr_showpicture
                dc.w rscr_showtext
                dc.w rscr_playmusic
                dc.w rscr_waitfire
                dc.w rscr_exit
                dc.w rscr_fademusic
                dc.w rscr_shop
                dc.w rscr_delay
                dc.w rscr_setitem
                dc.w rscr_clearitem
                dc.w rscr_setplotbit
                dc.w rscr_clearplotbit
                dc.w rscr_checkitem
                dc.w rscr_checkplotbit
                dc.w rscr_branch
                dc.w rscr_jump
                dc.w rscr_callcode
                dc.w rscr_warpplayer
                dc.w rscr_scroll

rscr_loadcutscene:
                lda (csptrlo),y
                jsr loadcutscene
                lda #$02
                rts
rscr_showpicture:
                lda (csptrlo),y
                jsr showpicture
                lda #$02
                rts
rscr_showtext:  lda (csptrlo),y
                jsr showtext
                lda #$02
                rts
rscr_playmusic: lda (csptrlo),y
                jsr playanytune
                lda #$02
                rts
rscr_waitfire:  jsr rscr_doall
                jsr getfireclick
                bcc rscr_waitfire
                lda #$01
                rts
rscr_exit:      lda #$00                          ;After running, clear the
                sta csptrlo                       ;script ptr
                sta csptrhi
                pla
                pla
                rts
rscr_fademusic: jsr fadetune
                lda #$01
                rts

rscr_doall:     jsr waitraster0
                jsr msgroutine
                jsr updatestatus
                jsr getcontrols
                rts

rscr_shop:      lda #$00
                sta shopselect
                lda (csptrlo),y
                sta shopptrlo
                iny
                lda (csptrlo),y
                sta shopptrhi
                ldy #$00                ;Get amount of items in shop
                lda (shopptrlo),y
                sta numshopitems
rscr_sloop:     lda shopselect
                asl
                asl
                tay
                iny
                sty shopindex
                iny
                lda (shopptrlo),y         ;Get item's text number
                asl
                tax
                lda LEVELSPRITES+2,x            ;Get text start address
                sta srclo
                lda LEVELSPRITES+3,x
                sta srchi
                ldy #$0c                        ;Initial row number
                jsr printtextc
rscr_swait:     jsr rscr_doall
                jsr changeweapon
                lda joystick
                and #JOY_UP+JOY_LEFT
                beq rscr_snotup
                lda prevjoy
                and #JOY_UP+JOY_LEFT
                bne rscr_snotup
                dec shopselect
                bpl rscr_sselect
                ldy numshopitems
                dey
                sty shopselect
                jmp rscr_sselect
rscr_snotup:    lda joystick
                and #JOY_DOWN+JOY_RIGHT
                beq rscr_snotdown
                lda prevjoy
                and #JOY_DOWN+JOY_RIGHT
                bne rscr_snotdown
                inc shopselect
                lda shopselect
                cmp numshopitems
                bcc rscr_sselect
                lda #$00
                sta shopselect
rscr_sselect:
                jmp rscr_sloop
rscr_snotdown:  jsr getfireclick
                bcc rscr_swait
                ldy shopindex                 ;Get item
                lda (shopptrlo),y             ;Zero=exit shop
                beq rscr_sexit
                sta tempval1
                iny
                iny
                iny
                lda (shopptrlo),y             ;Enough credits?
                sta tempval2
                and #$0f
                sta tempval3
                dey
                cmp creditshi                 ;Price highbyte
                beq rscr_schecklow
                bcc rscr_snoneed
                bcs rscr_snotenough
rscr_schecklow: lda creditslo
                cmp (shopptrlo),y             ;Price lowbyte
                bcc rscr_snotenough
rscr_snoneed:   lda tempval1                  ;Is it health item?
                cmp #ITEM_HEALTH
                bcc rscr_snohealth
                lda acthp                     ;If player health is maxed out
                cmp #PLRMAXHEALTH             ;then perform no purchase
                beq rscr_swait
                lda tempval2                  ;Use the highbyte in a perverted
                and #$f0                      ;way to determine health add
                lsr                           ;amount
                lsr
                clc
                adc acthp
                cmp #PLRMAXHEALTH+1
                bcc rscr_shealthok
                lda #PLRMAXHEALTH
rscr_shealthok: sta acthp
                jsr rscr_price
                jmp rscr_swait
rscr_snohealth: ldx tempval1                    ;If not health, then it's a
                lda ammolo,x                    ;weapon
                cmp #$99
                bne rscr_weaponok
                lda ammohi,x                    ;If ammo is maxed out (999)
                cmp #$09                        ;don't purchase
                beq rscr_dontbuy
rscr_weaponok:  jsr rscr_price
                txa
                jsr buyitem
rscr_dontbuy:   jmp rscr_swait
rscr_snotenough:lda #28
                sta msgnum
                jmp rscr_swait
rscr_sexit:     lda #$03
                rts
rscr_price:     sed
                lda creditslo
                sec
                sbc (shopptrlo),y
                sta creditslo
                lda creditshi
                sbc tempval3
                sta creditshi
                cld
                rts

rscr_delay:     lda (csptrlo),y
                sta tempval3
                iny
                lda (csptrlo),y
                sta tempval4
rscr_delayloop: jsr rscr_doall
                jsr getfireclick
                bcs rscr_delayquit
                dec tempval3
                lda tempval3
                cmp #$ff
                bne rscr_delayloop
                dec tempval4
                bpl rscr_delayloop
rscr_delayquit: lda #$03
                rts

rscr_setplotbit:lda (csptrlo),y
                jsr countbit
                lda plot
                ora tempval1
                sta plot
                lda #$02
                rts

rscr_clearplotbit:
                lda (csptrlo),y
                jsr countbit
                lda tempval1
                eor #$ff
                and plot
                sta plot
                lda #$02
                rts

rscr_checkplotbit:
                lda (csptrlo),y
                jsr countbit
                lda plot
                and tempval1
                sta tempval4
                lda #$02
                rts

rscr_setitem:   lda (csptrlo),y
                jsr countbit
                lda inventory1
                ora tempval1
                sta inventory1
                lda inventory2
                ora tempval2
                sta inventory2
                jsr drawitems
                lda #$02
                rts

rscr_clearitem: lda (csptrlo),y
                jsr countbit
                lda tempval1
                eor #$ff
                and inventory1
                sta inventory1
                lda tempval2
                eor #$ff
                and inventory2
                sta inventory2
                jsr drawitems
                lda #$02
                rts

rscr_checkitem: lda (csptrlo),y
                jsr countbit
                lda inventory1
                and tempval1
                sta tempval1
                lda inventory2
                and tempval2
                sta tempval2
                ora tempval1
                sta tempval4
                lda #$02
                rts

rscr_branch:    lda tempval4
                bne rscr_jump
                lda #$03
                rts

rscr_jump:      lda (csptrlo),y
                pha
                iny
                lda (csptrlo),y
                sta csptrhi
                pla
                sta csptrlo
                lda #$00
                rts

rscr_callcode:  lda (csptrlo),y
                sta rscr_call+1
                iny
                lda (csptrlo),y
                sta rscr_call+2
rscr_call:      jsr $0000
                lda #$03
                rts

rscr_warpplayer:lda (csptrlo),y
                sta wplr_targetlev+1
                iny
                lda (csptrlo),y
                sta wplr_targetx+1
                iny
                lda (csptrlo),y
                sta wplr_targety+1
                lda #$00
                sta csptrlo
                sta csptrhi
                pla
                pla
                jmp warpplayer2

rscr_scroll:    lda (csptrlo),y
                asl
                tax
                lda LEVELSPRITES+2,x            ;Get text start address
                sta srclo
                lda LEVELSPRITES+3,x
                sta srchi
                jsr cleartextscreen
                lda #$07
                sta scrolly
                lda #$00
                sta tempval1
                sta tempval2
                lda #SCRMODE_END
                sta screenmode
rscr_scrollloop:jsr getcontrols
                jsr getfireclick
                bcc rscr_scrollnofire
                jmp rscr_scrollover
rscr_scrollnofire:
                jsr waitraster0
                inc tempval1
                lda tempval1
                cmp #$03
                bcc rscr_scrollloop
                lda #$00
                sta tempval1
                dec scrolly
                bpl rscr_scrollloop
                lda #$07
                sta scrolly
                ldx #39
rscr_shiftloop:
N               SET 0
                REPEAT 19
                lda TEXTSCREEN+40+N*40,x
                sta TEXTSCREEN+N*40,x
N               SET N+1
                REPEND
                lda #$20
                sta TEXTSCREEN+19*40,x
                dex
                bpl rscr_shiftloop
                inc tempval2
                lda tempval2
                and #$01
                beq rscr_skiptext
                ldy #0
                lda (srclo),y   ;Text at end
                beq rscr_scrollstop
                ldy #19
                jsr printtextc
rscr_skiptext:  jmp rscr_scrollloop
rscr_scrollstop:jsr waitraster0
                jsr getcontrols
                jsr getfireclick
                bcc rscr_scrollstop
rscr_scrollover:lda #$02
                rts

;Ŀ
;UPLOADCODE                                                                   
;                                                                             
;Short cutscene when entering the final base.                                 
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

uploadcode:     jsr waitraster0
                jsr blankgamescreen
                ldy #7
                lda #<uploadtxt
                sta srclo
                lda #>uploadtxt
                sta srchi
                jsr printtextc
                ldy #$40
                ldx #0
uploadloop:     tya
                sta TEXTSCREEN+9*40+10,x
                iny
                cpy #$44
                bne uploadnot1
                ldy #$40
                inx
uploadnot1:     jsr waitraster0
                jsr waitraster0
                cpx #20
                bcc uploadloop
                lda #10
                sta tempval1
uploadloop2:    lda #<accesstxt1
                sta srclo
                lda #>accesstxt1
                sta srchi
                ldy #11
                jsr printtextc
                jsr uploaddelay
                lda #<accesstxt2
                sta srclo
                lda #>accesstxt2
                sta srchi
                ldy #11
                jsr printtextc
                jsr uploaddelay
                dec tempval1
                bne uploadloop2
                rts
uploaddelay:    ldx #$0a
uploaddlyloop:  jsr waitraster0
                dex
                bne uploaddlyloop
                rts

;Ŀ
;COUNTBONUSES                                                                 
;                                                                             
;Code that counts bonuses when game has been won.                             
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

countbonuses:   jsr fadetune
                jsr blankgamescreen
               lda soundmode
               sta count_restsm+1
               lda #$01
               sta soundmode
               jsr initsfx
               jsr stopmusic

countvictory:   lda #<victorybonus
               sta srclo
               lda #>victorybonus
               sta srchi
                ldy #0
                jsr printtextc
                jsr countdelay
                ldy #2
                jsr printtextc
                lda #$00
                sta tempval2
                lda #$50
                sta tempval1
countvictoryl:  lda tempval1
                lsr
                lsr
                lsr
                lsr
                ora #$30
                sta TEXTSCREEN+2*40+15
                lda tempval1
                and #$0f
                ora #$30
                sta TEXTSCREEN+2*40+16
                lda tempval1
                ora tempval2
                beq countvictoryd
                jsr waitraster0
                jsr waitraster0
                jsr waitraster0
                jsr countdec
                jsr add10000
                jsr drawscore
                jmp countvictoryl
countvictoryd:  jsr countdelay

countlives:     lda #<livesbonus
               sta srclo
               lda #>livesbonus
               sta srchi
                ldy #5
                jsr printtextc
                jsr countdelay
                ldy #7
                jsr printtextc
                lda #$00
                sta tempval2
                lda lives
                sta tempval1
countlivesl:    lda tempval1
               lsr
               lsr
               lsr
               lsr
               ora #$30
               sta TEXTSCREEN+7*40+15
               lda tempval1
               ora #$30
               sta TEXTSCREEN+7*40+16
                lda tempval1
                ora tempval2
                beq countlivesd
                jsr uploaddelay
                jsr countdec
                jsr add10000
                jsr drawscore
                jmp countlivesl
countlivesd:    jsr countdelay

countlevel:     lda #<explvlbonus
               sta srclo
               lda #>explvlbonus
               sta srchi
                ldy #10
                jsr printtextc
                jsr countdelay
                ldy #12
                jsr printtextc
                lda #$00
                sta tempval2
                lda explevel
                clc
                adc #$01
                sta tempval1
countlevell:    lda tempval1
               ora #$30
               sta TEXTSCREEN+12*40+15
                lda tempval1
                ora tempval2
                beq countleveld
                jsr uploaddelay
                jsr countdec
                jsr add10000
                jsr drawscore
                jmp countlevell
countleveld:    jsr countdelay

countweapons:   lda #<weaponbonus
               sta srclo
               lda #>weaponbonus
               sta srchi
                ldy #15
                jsr printtextc
                jsr countdelay
                ldy #17
                jsr printtextc
                ldx #$06
                lda #$00
                sta tempval2
                sta tempval1
countammo:      sed
               lda tempval1
               clc
               adc ammolo,x
               sta tempval1
               lda tempval2
               adc ammohi,x
               sta tempval2
               cld
               dex
               bne countammo
countweaponsl:  lda tempval2
                lsr
                lsr
                lsr
                lsr
                ora #$30
                sta TEXTSCREEN+17*40+14
                lda tempval2
               ora #$30
               sta TEXTSCREEN+17*40+15
                lda tempval1
                lsr
                lsr
                lsr
                lsr
                ora #$30
                sta TEXTSCREEN+17*40+16
                lda tempval1
                and #$0f
                ora #$30
                sta TEXTSCREEN+17*40+17
                lda tempval1
                ora tempval2
                beq countweaponsd
                jsr waitraster0
                jsr waitraster0
                jsr waitraster0
                jsr countdec
                jsr add500
                jsr drawscore
                jmp countweaponsl
countweaponsd:  jsr countdelay
count_restsm:   lda #$00
               sta soundmode
                rts

countdelay:     ldx #$14
countdlyloop:   jsr waitraster0
                dex
                bne countdlyloop
                rts

countdec:       sed
               lda tempval1
               sec
               sbc #$01
               sta tempval1
               lda tempval2
               sbc #$00
               sta tempval2
               cld
               lda #FX_PUNCH
               jsr playfx
               rts

add10000:       sed
               lda score+2
               clc
               adc #$01
               sta score+2
               lda score+3
               adc #$00
               sta score+3
               cld
               rts

add500:         sed
               lda score+1
               clc
               adc #$05
               sta score+1
               lda score+2
               adc #$00
               sta score+2
               lda score+3
               adc #$00
               sta score+3
               cld
               rts


