;ͻ
;Metal Warrior 2 - Bullet + shooting routines                                 
;Started in 9/1999!                                                           
;ͼ

MAXBULLETS      = 10
PLRBULLETS      = 6

WPN_FISTS       = 0
WPN_PISTOL      = 1
WPN_SMG         = 2
WPN_SHOTGUN     = 3
WPN_LASER       = 4
WPN_FLAME       = 5
WPN_GRENADES    = 6
WPN_MULTI1      = 9
WPN_MULTI2      = 12

BLT_EMPTY       = 0
BLT_PISTOL      = 1
BLT_LASER       = 2
BLT_FLAME       = 3
BLT_GRENADE     = 4
BLT_MELEE       = 5

EXPLOSIONDAMAGE = 16

WEAPON_START:

;Ŀ
;INITBULLETS                                                                  
;                                                                             
;Resets all bullets to inactive state.                                        
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

initbullets:    ldx #MAXBULLETS-1
                lda #$00
ib_loop:        sta bltt,x
                sta blterase,x
                dex
                bpl ib_loop
                rts

;Ŀ
;MOVEBULLETS                                                                  
;                                                                             
;Performs animation and movement of bullets.                                  
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

movebullets:    ldx #MAXBULLETS-1
mb_loop:        ldy bltt,x
                bne mb_active
mb_next:        dex
                bpl mb_loop
                rts
mb_active:      lda #CI_OBSTACLE
                sta mb_collisionbits+1
                cpy #BLT_FLAME
                bcc mb_noflame
                inc blttim,x
                cpy #BLT_GRENADE
                beq mb_grenade
mb_flame:       lda blttim,x
                cmp #$04
                bcc mb_noflame
                inc bltshape,x
                lda bltshape,x
                cmp #$ff
                bcc mb_resettime
                jmp mb_remove
mb_grenade:     lda bltsy,x
                bmi mb_nogroundcoll
                inc mb_collisionbits+1
mb_nogroundcoll:lda blttim,x
                cmp #$01
                bpl mb_grenade2
                jmp mb_explode
mb_grenade2:    bcc mb_noflame
                lda bltsy,x
                cmp #$08
                beq mb_resettime
                inc bltsy,x
mb_resettime:   lda #$00
                sta blttim,x
mb_noflame:     ldy #$00
                lda bltsx,x
                beq mb_nomovex
                bpl mb_xnotneg
                ldy #$ff
mb_xnotneg:     sty mb_xhigh+1
                clc
                adc bltxl,x
                sta bltxl,x
                lda bltxh,x
mb_xhigh:       adc #$00
                sta bltxh,x
mb_nomovex:     ldy #$00
                lda bltsy,x
                beq mb_nomovey
                bpl mb_ynotneg
                ldy #$ff
mb_ynotneg:     sty mb_yhigh+1
                clc
                adc bltyl,x
                sta bltyl,x
                lda bltyh,x
mb_yhigh:       adc #$00
                sta bltyh,x
mb_nomovey:     lda bltyh,x
                sta tempval2
                lda bltyl,x
                lsr tempval2
                ror
                lsr tempval2
                ror
                lsr tempval2
                ror
                sta tempval1
                and #3
                sta charblocky
                lda tempval1
                ldy tempval2
                lsr
                lsr
                clc
                adc rowhitbl,y
                sta charmapy
                lda bltxh,x
                sta tempval2
                lda bltxl,x
                lsr tempval2
                ror
                lsr tempval2
                ror
                lsr tempval2
                ror
                sta tempval1
                and #3
                sta charblockx
                lda tempval1
                ldy tempval2
                lsr
                lsr
                clc
                adc rowhitbl,y
                sta charmapx
                jsr getcharinfo
mb_collisionbits:
                and #CI_OBSTACLE                ;Collision with
                beq mb_jmpnext                  ;background happened?
mb_collision:   lda bltt,x
                cmp #BLT_GRENADE
                bne mb_remove
mb_explode:     lda #FX_EXPLOSION
                jsr playfx
                ldy #AN_GRENADE
                lda #AN_LASTENEMY+1
                jsr getfreeactor
                bcc mb_remove
                lda bltxl,x
                sta actxl,y
                lda bltxh,x
                sta actxh,y
                lda bltyl,x
                sta actyl,y
                lda bltyh,x
                sta actyh,y
                lda #ACT_EXPLOSION
                sta actt,y
                lda #$00
                sta actf,y
                sta actfd,y
                jsr grenadecoll
mb_remove:      lda #$00                        ;Remove bullet
                sta bltt,x
mb_jmpnext:     jmp mb_next

        ;The collision detection when a grenade explodes
        ;Y:Explosion's actor number

grenadecoll:    stx grc_restx+1                 ;Get grenade's bullet number
                cpx #PLRBULLETS                 ;Check collision to player or
                bcs grc_player                  ;enemies?
                ldx #MAXACTORS-1
grc_enemies:    lda actt,x
                beq grc_enext
                lda acthp,x
                bne grc_echeck
grc_enext:      dex
                bne grc_enemies
grc_restx:      ldx #$00
                rts
grc_echeck:     jsr actorcollide
                bcc grc_enext
                sty tempval4
                lda #EXPLOSIONDAMAGE
                jsr doenemydamage
                ldy tempval4
                jmp grc_enext
grc_player:     lda actfls                    ;If player immortal then do no
                bne grc_restx                 ;explosiondamage
                ldx #$00
                jsr actorcollide
                bcc grc_restx
                tya
                tax
                jsr faceplayer
                tax
                lda dpd_facetable,x
                sta dpd_xspeed+1
                lda #EXPLOSIONDAMAGE
                jsr doplrdamage
                jmp grc_restx

;Ŀ
;AR_EXPLOSION                                                                 
;                                                                             
;Explosion animation                                                          
;                                                                             
;Parameters: X:Actor number                                                   
;Returns: -                                                                   
;Modifies: A                                                                  
;

ar_explosion:   lda #2
                jsr animdelay
                bcc arex_done
                inc actf,x
                lda actf,x
                cmp #$06
                bcc arex_done
                lda #$00
                sta actt,x
arex_done:      rts

;Ŀ
;PREPAREBULLETS                                                               
;                                                                             
;Prepares bullets to be drawn onto screen. To be called AFTER old bullets     
;have been erased from screen!                                                
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

preparebullets: lda scrollsubxl
                clc
                adc #31
                and #$f8
                sta srclo
                lda scrollsubxh
                adc #$00
                sta srchi
                lda scrollsubyl
                clc
                adc #54
                and #$f8
                sta destlo
                lda scrollsubyh
                adc #$00
                sta desthi
                ldx #MAXBULLETS-1
pb_loop:        ldy bltt,x
                beq pb_next
                cpy #BLT_MELEE                  ;Virtual "melee" bullet dis-
                beq pb_out                      ;appears right away
                lda bltxl,x                     ;Subtract scrollvalue
                sec                             ;from bullet coordinates
                sbc srclo                       ;to get screen pos.
                sta tempval1
                lda bltxh,x
                sbc srchi
                sta tempval2
                lda bltyl,x
                sec
                sbc destlo
                tay
                lda bltyh,x
                sbc desthi
                bne pb_out
                tya                             ;Convert Y to row
                lsr
                lsr
                lsr
                cmp #20                         ;Bullet out of screen?
                bcs pb_out
                tay
                lda screenrowtbllo,y
                sta bltscrlo,x
                lda screenrowtblhi,y
                sta bltscrhi,x
                lda tempval1                    ;Convert X to column
                lsr tempval2
                ror
                lsr tempval2
                ror
                lsr tempval2
                ror
                cmp #39                         ;Bullet out of screen?
                bcs pb_out
                adc bltscrlo,x
                sta bltscrlo,x
                bcc pb_next
                inc bltscrhi,x
                bne pb_next
pb_out:         lda #BLT_EMPTY                  ;Out of screen; reset bullet
                sta bltt,x
pb_next:        dex
                bpl pb_loop
                rts

;Ŀ
;DRAWBULLETS                                                                  
;                                                                             
;Draws bullets to screen, using information calculated by PREPAREBULLETS.     
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

drawbullets:    lda level
                cmp #$06
                beq db_level6
                ldx #MAXBULLETS-1
                ldy screennum
                lda screentblhi,y
                sta db_add+1
                ldy #$00
db_loop:        lda bltt,x
                beq db_next
                lda bltscrlo,x
                sta tempval1
                sta tempval3
                lda bltscrhi,x
                clc
db_add:         adc #$00
                sta tempval2
                and #$03
                ora #$d8
                sta tempval4
                lda (tempval1),y
                sta bltunder,x
                lda (tempval3),y
                sta bltcunder,x
                lda bltshape,x
                sta (tempval1),y
                sta blterase,x
                tay
                lda CHARCOLORS,y
                ldy #$00
                sta (tempval3),y
db_next:        dex
                bpl db_loop
                rts

db_level6:      ldx #MAXBULLETS-1     ;In level 6 bullets must not be drawn
                ldy screennum         ;on the foreground objects!
                lda screentblhi,y
                sta db6_add+1
                ldy #$00
db6_loop:       lda bltt,x
                beq db6_next
                lda bltscrlo,x
                sta tempval1
                sta tempval3
                lda bltscrhi,x
                clc
db6_add:        adc #$00
                sta tempval2
                and #$03
                ora #$d8
                sta tempval4
                lda (tempval1),y
                and #$20
                bne db6_next
                lda (tempval1),y
                sta bltunder,x
                lda (tempval3),y
                sta bltcunder,x
                lda bltshape,x
                sta (tempval1),y
                sta blterase,x
                tay
                lda CHARCOLORS,y
                ldy #$00
                sta (tempval3),y
db6_next:       dex
                bpl db6_loop
                rts

;Ŀ
;ERASEBULLETS                                                                 
;                                                                             
;Erases bullets from screen. To be called before any scrolling! :-)           
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

erasebullets:   ldx #$00
                ldy screennum
                lda screentblhi,y
                sta eb_add+1
                ldy #$00
eb_loop:        lda blterase,x
                beq eb_next
                tya
                sta blterase,x
                lda bltscrlo,x
                sta tempval1
                sta tempval3
                lda bltscrhi,x
                clc
eb_add:         adc #$00
                sta tempval2
                and #$03
                ora #$d8
                sta tempval4
                lda bltunder,x
                sta (tempval1),y
                lda bltcunder,x
                sta (tempval3),y
eb_next:        inx
                cpx #MAXBULLETS
                bcc eb_loop
                rts

;Ŀ
;CHANGEWEAPON                                                                 
;                                                                             
;Handles player weapon changing.                                              
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

changeweapon:   lda keyval
                cmp #KEY_SPACE
                bne chngw_not
                lda #FX_SELECT
                jsr playfx
chngw_loop:     inc weapon
chngw_upd:      lda weapon
                cmp #WPN_GRENADES+1
                bcc chngw_notover
chngw_fists:    lda #$00
                sta weapon
chngw_notover:  tax
                lda ammolo,x                    ;If weapon has zero ammo, go
                ora ammohi,x                    ;to next until one with ammo
                beq chngw_loop                  ;found
chngw_not:      rts

;Ŀ
;PLAYERSHOOT                                                                  
;                                                                             
;Handles player attacks.                                                      
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

playershoot:    lda actbits
                and #AB_HIT
                bne ps_noattack
                lda acthp                       ;No revenge attack when dead :)
                beq ps_noattack
                ldy actt
                cpy #ACT_PLAYERRUN
                beq ps_typeok
                cpy #ACT_PLAYERDUCK
                beq ps_typeok
ps_noattack:    rts
ps_typeok:      lda joystick
                and #JOY_FIRE
                beq ps_noattack
                lda weapon
                cmp #WPN_SMG
                beq ps_shoot
                cmp #WPN_LASER
                beq ps_shoot
                cmp #WPN_FLAME
                beq ps_shoot
                lda prevjoy
                and #JOY_FIRE
                bne ps_noattack
                lda weapon
                cmp #WPN_FISTS
                bne ps_shoot
ps_fists:       cpy #ACT_PLAYERDUCK             ;Ducking?
                beq ps_duckpunch
                lda actf                        ;Jumping?
                cmp #9
                beq ps_jumppunch
ps_standpunch:  cmp #11                         ;Already punching?
                bcs ps_noattack
                lda #11
                bne ps_punchok
ps_jumppunch:   cmp #13
                bcs ps_noattack
                lda #13
                bne ps_punchok
ps_duckpunch:   lda actf
                bne ps_noattack
                lda #1
ps_punchok:     sta actf
                lda #0
                sta actfd
ps_shoot:       ldx weapon
                lda actsd                       ;Shoot delay check
                beq ps_shootok
                rts
ps_shootok:     stx tempval1
                ldy #PLRBULLETS-1               ;Scan through empty bullets
ps_scanblt:     lda bltt,y
                beq ps_found
                dey
                bpl ps_scanblt
                rts
ps_found:       lda actd
                bne ps_xmodleft
ps_xmodright:   lda actxl
                clc
                adc weapxmodtbl,x
                sta bltxl,y
                lda actxh
                adc #$00
                sta bltxh,y
                lda weapspdxtbl,x
                sta bltsx,y
                jmp ps_xmoddone
ps_xmodleft:    lda actxl
                sec
                sbc weapxmodtbl,x
                sta bltxl,y
                lda actxh
                sbc #$00
                sta bltxh,y
                lda weapspdxtbl,x
                eor #$ff
                clc
                adc #$01
                sta bltsx,y
ps_xmoddone:    ldx actt
                lda actyl
                sec
                sbc actymodtbl-1,x
                sta bltyl,y
                lda actyh
                sbc #0
                sta bltyh,y
                ldx tempval1
                lda weapspdytbl,x
                sta bltsy,y
                lda weapblttbl,x
                jsr setbltshape
                ldx tempval1
                lda weapmultitbl,x              ;Several bullets?
                beq ps_lastblt
                tax
                jmp ps_shootok
ps_lastblt:     lda weapsndtbl,x
                jsr playfx
                lda weapdelaytbl,x
                sta actsd
                ldy weapon                      ;If other weapon than fists,
                beq ps_nodec                    ;decrease ammo and go back to
                sed
                lda ammolo,y
                sec
                sbc #$01
                sta ammolo,y
                lda ammohi,y
                sbc #$00
                sta ammohi,y
                cld
                lda ammolo,y
                ora ammohi,y
                beq ps_noammo
                rts
ps_noammo:      lda #26
                sta msgnum
                jmp chngw_fists
ps_nodec:       rts

;Ŀ
;ENEMYSHOOT                                                                   
;                                                                             
;Handles enemy attacks. This must only be called if player is alive!          
;                                                                             
;Parameters: A:Type of weapon                                                 
;            X:Actor number                                                   
;            Y:X modification of bullet pos.                                  
;Returns: C=0 failure, C=1 success, Y returns bullet number for further       
;         modifications                                                       
;Modifies: A,X,Y                                                              
;

enemyshoot:     sta tempval1                    ;Save weapon
                sty srclo                       ;Save Xmod
                stx tempval4                    ;Save actor number
                ldy actt,x
                ldx #$00
                lda actymodtbl-1,y
                sta srchi                       ;Save Ymod
                bpl es_ymodnotneg
                ldx #$ff
es_ymodnotneg:  stx es_ymodhigh+1
                ldx tempval4
                lda actsd,x                     ;Shoot delay check
                beq es_shootok
                clc                             ;Return failure
                rts
es_shootok:     ldy #MAXBULLETS-1               ;Scan through empty bullets
es_scanblt:     lda bltt,y
                beq es_found
                dey
                cpy #PLRBULLETS
                bcs es_scanblt
                clc                             ;Return failure; no free
                rts                             ;bullets
es_found:       lda actyl,x                     ;Copy Y position and apply
                sec                             ;modification
                sbc srchi
                sta bltyl,y
                lda actyh,x
es_ymodhigh:    sbc #$00
                sta bltyh,y
                lda actd,x                      ;Check direction
                bne es_xmodleft
es_xmodright:   lda actxl,x
                clc
                adc srclo
                sta bltxl,y
                lda actxh,x
                adc #$00
                sta bltxh,y
                ldx tempval1                    ;Now get weapon number
                lda weapspdxtbl,x               ;and get X-speed
                sta bltsx,y
                jmp es_xmoddone
es_xmodleft:    lda actxl,x
                sec
                sbc srclo
                sta bltxl,y
                lda actxh,x
                sbc #$00
                sta bltxh,y
                ldx tempval1                    ;Now get weapon number
                lda weapspdxtbl,x               ;and get X-speed
                eor #$ff                        ;Negate it
                clc
                adc #$01
                sta bltsx,y
es_xmoddone:    lda weapspdytbl,x               ;Get Y-speed
                sta bltsy,y
                lda weapblttbl,x                ;Set type & shape
                jsr setbltshape                 ;(X is destroyed)
                ldx tempval1
                lda weapmultitbl,x              ;Several bullets?
                beq es_lastblt
                sta tempval1                    ;Save new weaponnum
                ldx tempval4                    ;Get actor number back
                jmp es_shootok
es_lastblt:     lda weapsndtbl,x
                jsr playfx
                lda weapdelaytbl,x
                ldx tempval4                    ;Get actor number back
                sta actsd,x
                sec                             ;Success!
                rts

;Ŀ
;SETBLTSHAPE                                                                  
;                                                                             
;Sets bullet type & shape (character)                                         
;                                                                             
;Parameters: A:bullet type, Y:bullet number                                   
;Returns: -                                                                   
;Modifies: A,X,Tempval2,Tempval3                                              
;

setbltshape:    sta bltt,y
                asl                             ;Multiply bullet type by 9
                asl                             ;for direction table
                asl
                adc bltt,y
                sta tempval2
                lda bltsx,y                     ;Convert X speed to 0...2
                beq sbs_xzero
                bpl sbs_xpos                    ;range
sbs_xneg:       lda #$00
                beq sbs_xdone
sbs_xzero:      lda #$01
                bne sbs_xdone
sbs_xpos:       lda #$02
sbs_xdone:      clc
                adc tempval2
                sta tempval2
                lda bltsy,y                     ;Do same for Y speed
                beq sbs_yzero
                bpl sbs_ypos
sbs_yneg:       lda #$00
                beq sbs_ydone
sbs_yzero:      lda #$01
                bne sbs_ydone
sbs_ypos:       lda #$02
sbs_ydone:      sta tempval3
                asl                             ;Multiply Y speed by 3
                adc tempval3
                adc tempval2
                tax
                lda bltdirtbl-9,x
                sta bltshape,y
                lda #$00
                sta blttim,y
                rts

;Ŀ
;SETWEAPON                                                                    
;                                                                             
;Sets the correct animation for the player, according to weapon + draws the   
;weapon to scorescreen.                                                       
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

setweapon:      ldx weapon
                stx prevweapon
                ldy #$00
                lda weapanimtbl,x
                beq setw_normal
setw_loop1:     sta ad_playerrun+8,y
                iny
                iny
                cpy #20
                bcc setw_loop1
                dec ad_playerrun+8
                dec ad_playerrun+8+8
                dec ad_playerrun+8+16
                jmp setw_finish
setw_normal:    ldx #$00
setw_normalloop:lda weapanimtbl2,x
                sta ad_playerrun+8,y
                inx
                iny
                iny
                cpy #20
                bcc setw_normalloop
setw_finish:    ldy #$00
setw_loop2:     lda ad_playerrun+8,y
                clc
                adc #23
                sta ad_playerrun+8+30,y
                iny
                iny
                cpy #20
                bcc setw_loop2
                lda ad_playerrun+8
                sta ad_playerduck+8
                lda ad_playerrun+8+30
                sta ad_playerduck+8+6
                ldx #$02
setw_loop3:     lda weapchartbl,x
                sta TEXTSCREEN+21*40+15,x
                lda weapchartbl+3,x
                sta TEXTSCREEN+22*40+15,x
                dex
                bpl setw_loop3
                lda weapon
                and #$03
                tax
                lda rowhitbl,x
                sta srclo
                lda weapon
                lsr
                lsr
                clc
                adc #$e0
                sta srchi
                ldx #$02
                ldy #36
setw_loop4:     lda (srclo),y
                sta TEXTCHARS+86*8,x
                iny
                lda (srclo),y
                sta TEXTCHARS+87*8,x
                iny
                lda (srclo),y
                sta TEXTCHARS+88*8,x
                iny
                inx
                cpx #$08
                bne setw_loop4
                ldx #$00
setw_loop5:     lda (srclo),y
                sta TEXTCHARS+89*8,x
                iny
                lda (srclo),y
                sta TEXTCHARS+90*8,x
                iny
                lda (srclo),y
                sta TEXTCHARS+91*8,x
                iny
                inx
                cpx #$03
                bne setw_loop5
                rts

;Ŀ
;ENEMYDAMAGE                                                                  
;                                                                             
;Checks collisions of player bullets to enemies.                              
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

enemydamage:    lda explevel                    ;Damage of player's punches is
                asl                             ;3 + experience level * 2
                adc #$03
                sta bltdmgtbl+BLT_MELEE-1
                ldy #PLRBULLETS-1               ;Start from last player bullet
edmg_loop:      lda bltt,y                      ;Is bullet active
                beq edmg_nextblt
                ldx #MAXACTORS-1                ;Start from last actor
edmg_loop2:     lda actt,x                      ;Actor must be active and have
                beq edmg_nextenemy
                lda acthp,x                     ;hitpoints left
                bne edmg_check
edmg_nextenemy: dex
                bne edmg_loop2
edmg_nextblt:   dey
                bpl edmg_loop
                rts
edmg_check:     jsr actbltcollide
                bcc edmg_nextenemy
                lda bltt,y
                cmp #BLT_GRENADE
                beq edmg_grenade
                lda bltt,y
                pha
                lda #$00
                sta bltt,y
                sty tempval4
                pla
                tay
                lda bltdmgtbl-1,y
                jsr doenemydamage
                ldy tempval4
                jmp edmg_nextblt
edmg_grenade:   lda #$80
                sta blttim,y
                jmp edmg_nextblt

;Ŀ
;DOENEMYDAMAGE                                                                
;                                                                             
;Does damage to enemy actor.                                                  
;                                                                             
;Parameters: X:Actor, A:Damage                                                
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

doenemydamage:  ldy actt,x
                sec
                sbc actleveltbl-ACT_FISTMAN,y
                bpl ded_notneg
                lda #$01
ded_notneg:     bne ded_dmgok
                lda #$01
ded_dmgok:      sta ded_sub+1
                lda acthp,x
                sec
ded_sub:        sbc #$00
                bcs ded_notover
                lda #$00
ded_notover:    sta acthp,x
                bne ded_stillalive
                lda #$ff                        ;Reset the origin immediately
                sta actorg,x                    ;so that no enemy can come
ded_stillalive: lda #$02                        ;"back from the dead" :-)
                sta actfls,x
                lda #FX_HIT
                jsr playfx
                rts

;Ŀ
;PLAYERDAMAGE                                                                 
;                                                                             
;Checks collisions of enemy bullets to player.                                
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

playerdamage:   lda actfls                      ;Player immortal now?
                beq pdmg_ok
                rts
pdmg_ok:        lda #$02                        ;Damage of enemy punches is
                sta bltdmgtbl+BLT_MELEE-1       ;always 2
                ldy #PLRBULLETS                 ;Start from first enemy bullet
pdmg_loop:      lda bltt,y                      ;Is bullet active
                beq pdmg_nextblt
                ldx #0
                jsr actbltcollide
                bcc pdmg_nextblt
                lda bltt,y
                cmp #BLT_GRENADE
                beq pdmg_grenade
                lda bltsx,y
                bmi pdmg_spdneg
                lda #2*8
                bne pdmg_spddone
pdmg_spdneg:    lda #-2*8
pdmg_spddone:   sta dpd_xspeed+1
                lda bltt,y
                pha
                lda #$00
                sta bltt,y
                sty tempval4
                pla
                tay
                lda bltdmgtbl-1,y
                jsr doplrdamage
                ldy tempval4
pdmg_nextblt:   iny
                cpy #MAXBULLETS
                bcc pdmg_loop
                rts
pdmg_grenade:   lda #$80
                sta blttim,y
                jmp pdmg_nextblt

;Ŀ
;DOPLRDAMAGE                                                                  
;                                                                             
;Does damage to player.                                                       
;                                                                             
;Parameters: A:Damage                                                         
;Returns: -                                                                   
;Modifies: A                                                                  
;

doplrdamage:    pha
                lda acthp
                beq dpd_immortal
                lda actt                ;When entering a door, player cannot
                cmp #ACT_PLAYERDOOR     ;take damage
                beq dpd_immortal
                pla
                sec
                sbc explevel
                bmi dpd_neg
dpd_notneg:     bne dpd_dmgok
dpd_neg:        lda #$01
dpd_dmgok:      sta dpd_sub+1
                lda cheaton
                bne dpd_subok2
                lda acthp
                sec
dpd_sub:        sbc #$00
                bpl dpd_subok
                lda #$00
dpd_subok:      sta acthp
                beq dpd_xspeed
dpd_subok2:     lda #FX_HIT
                jsr playfx
                lda actbits
                and #AB_HIT
                bne dpd_nonewhit
dpd_xspeed:     lda #$00
                sta actsx
                lda #-4*8
                sta actsy
                lda acthp
                bne dpd_notdead
                lda #FX_DEATH
                jsr playfx
dpd_notdead:    lda #AB_HIT+AB_JUMP
                sta actbits
                lda #ACT_PLAYERRUN
                sta actt
                lda #10
                sta actf
dpd_nonewhit:   lda #$02
                sta actfls
                rts
dpd_immortal:   pla
                rts

